/**
 * generated by Xtext 2.9.1
 */
package org.xtext.example.feature.generator;

import com.google.common.base.Objects;
import com.google.common.collect.Iterables;
import com.google.common.collect.LinkedListMultimap;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.Conversions;
import org.eclipse.xtext.xbase.lib.InputOutput;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.eclipse.xtext.xbase.lib.ListExtensions;
import org.eclipse.xtext.xbase.lib.Pair;
import org.eclipse.xtext.xbase.lib.StringExtensions;
import org.xtext.example.feature.feature.Background;
import org.xtext.example.feature.feature.Examples;
import org.xtext.example.feature.feature.Feature;
import org.xtext.example.feature.feature.Scenario;
import org.xtext.example.feature.feature.ScenarioOutline;
import org.xtext.example.feature.feature.Step;
import org.xtext.example.feature.feature.Table;

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
@SuppressWarnings("all")
public class FeatureGenerator extends AbstractGenerator {
  private HashMap<String, HashMap<String, ArrayList<String>>> methods = new HashMap<String, HashMap<String, ArrayList<String>>>();
  
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    TreeIterator<EObject> _allContents = resource.getAllContents();
    Iterable<EObject> _iterable = IteratorExtensions.<EObject>toIterable(_allContents);
    Iterable<Feature> _filter = Iterables.<Feature>filter(_iterable, Feature.class);
    for (final Feature e : _filter) {
      {
        this.generateRepositories(fsa, e);
        String _generateMock = this.generateMock(e);
        fsa.generateFile(
          "com/example/Skeleton.java", _generateMock);
        String _generateHelper = this.generateHelper(e);
        fsa.generateFile(
          "com/example/SkeletonHelper.java", _generateHelper);
        String _generateTest = this.generateTest(e);
        fsa.generateFile(
          "com/example/SkeletonTest.java", _generateTest);
      }
    }
  }
  
  public void generateRepositories(final IFileSystemAccess2 fsa, final Feature feature) {
    Background _background = feature.getBackground();
    EList<Step> _steps = _background.getSteps();
    for (final Step step : _steps) {
      EList<Table> _tables = step.getTables();
      for (final Table table : _tables) {
        {
          String _description = step.getDescription();
          String _description_1 = step.getDescription();
          int _indexOf = _description_1.indexOf("following $");
          int _length = "following $".length();
          int _plus = (_indexOf + _length);
          String type = _description.substring(_plus);
          int _length_1 = type.length();
          int _minus = (_length_1 - 1);
          String _substring = type.substring(0, _minus);
          type = _substring;
          CharSequence _generateMockRepository = this.generateMockRepository(type);
          fsa.generateFile(
            (("com/example/models/Mock" + type) + "Repository.java"), _generateMockRepository);
          CharSequence _generateJpaRepository = this.generateJpaRepository(type);
          fsa.generateFile(
            (("com/example/models/" + type) + "Repository.java"), _generateJpaRepository);
        }
      }
    }
  }
  
  public CharSequence generateMockRepository(final String type) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package com.example.models;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("import org.springframework.data.repository.CrudRepository;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("public interface Mock");
    _builder.append(type, "");
    _builder.append("Repository extends CrudRepository<");
    _builder.append(type, "");
    _builder.append(", Long>{");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence generateJpaRepository(final String type) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package com.example.models;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("import org.springframework.data.jpa.repository.JpaRepository;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("public interface ");
    _builder.append(type, "");
    _builder.append("Repository extends JpaRepository<");
    _builder.append(type, "");
    _builder.append(", Long>{");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  public String generateMock(final Feature feature) {
    String _xblockexpression = null;
    {
      HashMap<String, HashMap<String, ArrayList<String>>> _hashMap = new HashMap<String, HashMap<String, ArrayList<String>>>();
      this.methods = _hashMap;
      LinkedHashMap<String, Pair<String, String>> typeMap = new LinkedHashMap<String, Pair<String, String>>();
      String fixtures = new String();
      Background _background = feature.getBackground();
      EList<Step> _steps = _background.getSteps();
      for (final Step step : _steps) {
        EList<Table> _tables = step.getTables();
        for (final Table table : _tables) {
          {
            String _description = step.getDescription();
            String _description_1 = step.getDescription();
            int _indexOf = _description_1.indexOf("following $");
            int _length = "following $".length();
            int _plus = (_indexOf + _length);
            String type = _description.substring(_plus);
            int _length_1 = type.length();
            int _minus = (_length_1 - 1);
            String _substring = type.substring(0, _minus);
            type = _substring;
            String _firstLower = StringExtensions.toFirstLower(type);
            String _plus_1 = ((fixtures + "\tString[] ") + _firstLower);
            String _plus_2 = (_plus_1 + "Fixtures = {\n");
            fixtures = _plus_2;
            String _firstLower_1 = StringExtensions.toFirstLower(type);
            String _plus_3 = (_firstLower_1 + "Repo");
            String _firstLower_2 = StringExtensions.toFirstLower(type);
            String _plus_4 = (_firstLower_2 + "Fixtures");
            int _length_2 = type.length();
            String _substring_1 = type.substring(0, _length_2);
            Pair<String, String> _pair = new Pair<String, String>(_plus_4, _substring_1);
            typeMap.put(_plus_3, _pair);
            EList<String> _rows = table.getRows();
            String titleRow = _rows.get(0);
            String[] titleArray = titleRow.split("\\|", (-1));
            final String[] _converted_titleArray = (String[])titleArray;
            final String[] _converted_titleArray_1 = (String[])titleArray;
            int _size = ((List<String>)Conversions.doWrapArray(_converted_titleArray_1)).size();
            int _minus_1 = (_size - 1);
            List<String> _subList = ((List<String>)Conversions.doWrapArray(_converted_titleArray)).subList(1, _minus_1);
            titleArray = ((String[])Conversions.unwrapArray(_subList, String.class));
            EList<String> _rows_1 = table.getRows();
            EList<String> _rows_2 = table.getRows();
            int _size_1 = _rows_2.size();
            List<String> _subList_1 = _rows_1.subList(1, _size_1);
            for (final String valueRow : _subList_1) {
              {
                String[] valueArray = valueRow.split("\\|", (-1));
                final String[] _converted_valueArray = (String[])valueArray;
                final String[] _converted_valueArray_1 = (String[])valueArray;
                int _size_2 = ((List<String>)Conversions.doWrapArray(_converted_valueArray_1)).size();
                int _minus_2 = (_size_2 - 1);
                List<String> _subList_2 = ((List<String>)Conversions.doWrapArray(_converted_valueArray)).subList(1, _minus_2);
                valueArray = ((String[])Conversions.unwrapArray(_subList_2, String.class));
                boolean firstIteration = true;
                fixtures = (fixtures + "\t\t\"{");
                for (final String item : titleArray) {
                  {
                    final String[] _converted_titleArray_2 = (String[])titleArray;
                    int _indexOf_1 = ((List<String>)Conversions.doWrapArray(_converted_titleArray_2)).indexOf(item);
                    String _get = valueArray[_indexOf_1];
                    String value = _get.trim();
                    String _xifexpression = null;
                    boolean _startsWith = value.startsWith("#{$");
                    if (_startsWith) {
                      _xifexpression = "%s";
                    } else {
                      _xifexpression = "\\\"%s\\\"";
                    }
                    String strFormat = ("%s\"%s\\\":" + _xifexpression);
                    String _xifexpression_1 = null;
                    if (firstIteration) {
                      _xifexpression_1 = "\\";
                    } else {
                      _xifexpression_1 = ",\\";
                    }
                    String _trim = item.trim();
                    String _format = String.format(strFormat, _xifexpression_1, _trim, value);
                    String _plus_5 = (fixtures + _format);
                    fixtures = _plus_5;
                    firstIteration = false;
                  }
                }
                fixtures = (fixtures + "}\",\n");
              }
            }
            fixtures = (fixtures + "\t};\n");
          }
        }
      }
      Pattern tableHeaderPattern = Pattern.compile("(\\w+)");
      Pattern whenStepPattern = Pattern.compile(".+?\\bcalls?\\s+(\\\'\\w+\\\'|<\\w+>)\\s+using\\s+(\\\'\\w+\\\'|<\\w+>)\\s+on\\s+(\\\'\\w+\\\'|<\\w+>)(?:\\s+with\\s+(\\\'\\w+\\\'|<\\w+>))?");
      Pattern pathVariablePattern = Pattern.compile("/\\{(\\w+)\\}/?");
      Pattern objectFromRepoVariablePattern = Pattern.compile("findOne\\((\\w+)\\)");
      Pattern statusPattern = Pattern.compile("[.+]?status.+must\\sbe\\s(<\\w+>|\'\\w+\')");
      Pattern locationPattern = Pattern.compile("[.+]?location.+should\\shave\\s(<\\w+>|\'\\w+\')");
      Pattern patchPattern = Pattern.compile("[.+]?must\\scontain.+\\((<\\w+>|\'\\w+\'),[\\s]?(<\\w+>|\'\\w+\')\\)");
      Pattern objectFromRepoPattern = Pattern.compile("[.+]?<\\w+>\\sshould\\sbe\\s(\'.*\')");
      Pattern testVariableCheckPattern = Pattern.compile("\'(\\w+)\'\\smust\\sbe\\s<(\\w+)>");
      StringConcatenation _builder = new StringConcatenation();
      String methodBody = _builder.toString();
      EList<EObject> _scenarios = feature.getScenarios();
      for (final EObject scenario : _scenarios) {
        if ((scenario instanceof ScenarioOutline)) {
          LinkedHashMap<String, String> methodStructureMap = new LinkedHashMap<String, String>();
          String _title = ((ScenarioOutline)scenario).getTitle();
          String _title_1 = ((ScenarioOutline)scenario).getTitle();
          int _lastIndexOf = _title_1.lastIndexOf(" ");
          int _plus = (_lastIndexOf + 1);
          String object = _title.substring(_plus);
          LinkedListMultimap<String, String> associationTable = LinkedListMultimap.<String, String>create();
          ArrayList<String> variables = new ArrayList<String>();
          ScenarioOutline scOutline = ((ScenarioOutline) scenario);
          HashMap<String, ArrayList<String>> methodStrMap = new HashMap<String, ArrayList<String>>();
          Examples _examples = scOutline.getExamples();
          Table _table = _examples.getTable();
          EList<String> _rows = _table.getRows();
          String header = _rows.get(0);
          Matcher headerMatcher = tableHeaderPattern.matcher(header);
          while (headerMatcher.find()) {
            String _group = headerMatcher.group(1);
            variables.add(_group);
          }
          InputOutput.<ArrayList<String>>println(variables);
          boolean firstTime = true;
          Examples _examples_1 = scOutline.getExamples();
          Table _table_1 = _examples_1.getTable();
          EList<String> _rows_1 = _table_1.getRows();
          for (final String row : _rows_1) {
            {
              if ((!firstTime)) {
                StringTokenizer tokenizer = new StringTokenizer(row, "|");
                int pos = 0;
                while (tokenizer.hasMoreTokens()) {
                  int _size = variables.size();
                  boolean _lessThan = (pos < _size);
                  if (_lessThan) {
                    int _plusPlus = pos++;
                    String _get = variables.get(_plusPlus);
                    String _nextToken = tokenizer.nextToken();
                    String _trim = _nextToken.trim();
                    associationTable.put(_get, _trim);
                  } else {
                    tokenizer.nextToken();
                  }
                }
              }
              firstTime = false;
            }
          }
          LinkedList<String> stepMatchingVariables = new LinkedList<String>();
          while ((stepMatchingVariables.size() < 12)) {
            stepMatchingVariables.add(null);
          }
          EList<Step> _steps_1 = scOutline.getSteps();
          for (final Step step_1 : _steps_1) {
            {
              Examples _examples_2 = scOutline.getExamples();
              Table _table_2 = _examples_2.getTable();
              EList<String> _rows_2 = _table_2.getRows();
              int _size = _rows_2.size();
              int exampleRowSIze = (_size - 1);
              String _description = step_1.getDescription();
              Matcher whenStepMatcher = whenStepPattern.matcher(_description);
              String _description_1 = step_1.getDescription();
              Matcher statusStepMatcher = statusPattern.matcher(_description_1);
              String _description_2 = step_1.getDescription();
              Matcher locationStepMatcher = locationPattern.matcher(_description_2);
              String _description_3 = step_1.getDescription();
              Matcher patchStepMatcher = patchPattern.matcher(_description_3);
              String _description_4 = step_1.getDescription();
              Matcher objectFromRepoMatcher = objectFromRepoPattern.matcher(_description_4);
              String _description_5 = step_1.getDescription();
              Matcher testVariableCheckMatcher = testVariableCheckPattern.matcher(_description_5);
              while (whenStepMatcher.find()) {
                boolean _and = false;
                boolean _and_1 = false;
                String _group = whenStepMatcher.group(1);
                boolean _notEquals = (!Objects.equal(_group, null));
                if (!_notEquals) {
                  _and_1 = false;
                } else {
                  String _group_1 = whenStepMatcher.group(2);
                  boolean _notEquals_1 = (!Objects.equal(_group_1, null));
                  _and_1 = _notEquals_1;
                }
                if (!_and_1) {
                  _and = false;
                } else {
                  String _group_2 = whenStepMatcher.group(3);
                  boolean _notEquals_2 = (!Objects.equal(_group_2, null));
                  _and = _notEquals_2;
                }
                if (_and) {
                  String _group_3 = whenStepMatcher.group(1);
                  String _group_4 = whenStepMatcher.group(1);
                  int _length = _group_4.length();
                  int _minus = (_length - 1);
                  String _substring = _group_3.substring(1, _minus);
                  stepMatchingVariables.set(0, _substring);
                  String _group_5 = whenStepMatcher.group(2);
                  String _group_6 = whenStepMatcher.group(2);
                  int _length_1 = _group_6.length();
                  int _minus_1 = (_length_1 - 1);
                  String _substring_1 = _group_5.substring(1, _minus_1);
                  stepMatchingVariables.set(1, _substring_1);
                  String _group_7 = whenStepMatcher.group(3);
                  String _group_8 = whenStepMatcher.group(3);
                  int _length_2 = _group_8.length();
                  int _minus_2 = (_length_2 - 1);
                  String _substring_2 = _group_7.substring(1, _minus_2);
                  stepMatchingVariables.set(2, _substring_2);
                  String _group_9 = whenStepMatcher.group(4);
                  boolean _notEquals_3 = (!Objects.equal(_group_9, null));
                  if (_notEquals_3) {
                    String _group_10 = whenStepMatcher.group(4);
                    String _group_11 = whenStepMatcher.group(4);
                    int _length_3 = _group_11.length();
                    int _minus_3 = (_length_3 - 1);
                    String _substring_3 = _group_10.substring(1, _minus_3);
                    stepMatchingVariables.set(3, _substring_3);
                  }
                  boolean _and_2 = false;
                  String _group_12 = whenStepMatcher.group(1);
                  boolean _startsWith = _group_12.startsWith("<");
                  boolean _not = (!_startsWith);
                  if (!_not) {
                    _and_2 = false;
                  } else {
                    String _group_13 = whenStepMatcher.group(2);
                    boolean _startsWith_1 = _group_13.startsWith("<");
                    boolean _not_1 = (!_startsWith_1);
                    _and_2 = _not_1;
                  }
                  if (_and_2) {
                    String _group_14 = whenStepMatcher.group(1);
                    String _group_15 = whenStepMatcher.group(1);
                    int _length_4 = _group_15.length();
                    int _minus_4 = (_length_4 - 1);
                    String _substring_4 = _group_14.substring(1, _minus_4);
                    String _group_16 = whenStepMatcher.group(2);
                    String _group_17 = whenStepMatcher.group(2);
                    int _length_5 = _group_17.length();
                    int _minus_5 = (_length_5 - 1);
                    String _substring_5 = _group_16.substring(1, _minus_5);
                    methodStructureMap.put(_substring_4, _substring_5);
                  } else {
                    boolean _and_3 = false;
                    String _group_18 = whenStepMatcher.group(1);
                    boolean _startsWith_2 = _group_18.startsWith("<");
                    if (!_startsWith_2) {
                      _and_3 = false;
                    } else {
                      String _group_19 = whenStepMatcher.group(2);
                      boolean _startsWith_3 = _group_19.startsWith("<");
                      boolean _not_2 = (!_startsWith_3);
                      _and_3 = _not_2;
                    }
                    if (_and_3) {
                      for (int count = 0; (count < exampleRowSIze); count++) {
                        String _group_20 = whenStepMatcher.group(1);
                        String _group_21 = whenStepMatcher.group(1);
                        int _length_6 = _group_21.length();
                        int _minus_6 = (_length_6 - 1);
                        String _substring_6 = _group_20.substring(1, _minus_6);
                        List<String> _get = associationTable.get(_substring_6);
                        String _get_1 = _get.get(count);
                        String _group_22 = whenStepMatcher.group(2);
                        String _group_23 = whenStepMatcher.group(2);
                        int _length_7 = _group_23.length();
                        int _minus_7 = (_length_7 - 1);
                        String _substring_7 = _group_22.substring(1, _minus_7);
                        methodStructureMap.put(_get_1, _substring_7);
                      }
                    } else {
                      boolean _and_4 = false;
                      String _group_20 = whenStepMatcher.group(1);
                      boolean _startsWith_4 = _group_20.startsWith("<");
                      boolean _not_3 = (!_startsWith_4);
                      if (!_not_3) {
                        _and_4 = false;
                      } else {
                        String _group_21 = whenStepMatcher.group(2);
                        boolean _startsWith_5 = _group_21.startsWith("<");
                        _and_4 = _startsWith_5;
                      }
                      if (_and_4) {
                        for (int count = 0; (count < exampleRowSIze); count++) {
                          String _group_22 = whenStepMatcher.group(1);
                          String _group_23 = whenStepMatcher.group(1);
                          int _length_6 = _group_23.length();
                          int _minus_6 = (_length_6 - 1);
                          String _substring_6 = _group_22.substring(1, _minus_6);
                          String _group_24 = whenStepMatcher.group(2);
                          String _group_25 = whenStepMatcher.group(2);
                          int _length_7 = _group_25.length();
                          int _minus_7 = (_length_7 - 1);
                          String _substring_7 = _group_24.substring(1, _minus_7);
                          List<String> _get = associationTable.get(_substring_7);
                          String _get_1 = _get.get(count);
                          methodStructureMap.put(_substring_6, _get_1);
                        }
                      } else {
                        boolean _and_5 = false;
                        String _group_22 = whenStepMatcher.group(1);
                        boolean _startsWith_6 = _group_22.startsWith("<");
                        if (!_startsWith_6) {
                          _and_5 = false;
                        } else {
                          String _group_23 = whenStepMatcher.group(2);
                          boolean _startsWith_7 = _group_23.startsWith("<");
                          _and_5 = _startsWith_7;
                        }
                        if (_and_5) {
                          for (int count = 0; (count < exampleRowSIze); count++) {
                            String _group_24 = whenStepMatcher.group(1);
                            String _group_25 = whenStepMatcher.group(1);
                            int _length_6 = _group_25.length();
                            int _minus_6 = (_length_6 - 1);
                            String _substring_6 = _group_24.substring(1, _minus_6);
                            List<String> _get = associationTable.get(_substring_6);
                            String _get_1 = _get.get(count);
                            String _group_26 = whenStepMatcher.group(2);
                            String _group_27 = whenStepMatcher.group(2);
                            int _length_7 = _group_27.length();
                            int _minus_7 = (_length_7 - 1);
                            String _substring_7 = _group_26.substring(1, _minus_7);
                            List<String> _get_2 = associationTable.get(_substring_7);
                            String _get_3 = _get_2.get(count);
                            methodStructureMap.put(_get_1, _get_3);
                          }
                        }
                      }
                    }
                  }
                }
              }
              while (testVariableCheckMatcher.find()) {
                boolean _and = false;
                String _group = testVariableCheckMatcher.group(1);
                boolean _notEquals = (!Objects.equal(_group, null));
                if (!_notEquals) {
                  _and = false;
                } else {
                  String _group_1 = testVariableCheckMatcher.group(2);
                  boolean _notEquals_1 = (!Objects.equal(_group_1, null));
                  _and = _notEquals_1;
                }
                if (_and) {
                  String _group_2 = testVariableCheckMatcher.group(1);
                  stepMatchingVariables.set(10, _group_2);
                  String _group_3 = testVariableCheckMatcher.group(2);
                  stepMatchingVariables.set(11, _group_3);
                }
              }
              boolean _find = statusStepMatcher.find();
              if (_find) {
                String _group = statusStepMatcher.group(1);
                String _group_1 = statusStepMatcher.group(1);
                int _length = _group_1.length();
                int _minus = (_length - 1);
                String _substring = _group.substring(1, _minus);
                stepMatchingVariables.set(4, _substring);
              }
              boolean _find_1 = locationStepMatcher.find();
              if (_find_1) {
                String _group_2 = locationStepMatcher.group(1);
                String _group_3 = locationStepMatcher.group(1);
                int _length_1 = _group_3.length();
                int _minus_1 = (_length_1 - 1);
                String _substring_1 = _group_2.substring(1, _minus_1);
                stepMatchingVariables.set(5, _substring_1);
              }
              boolean _find_2 = patchStepMatcher.find();
              if (_find_2) {
                String _get = stepMatchingVariables.get(6);
                boolean _notEquals = (!Objects.equal(_get, null));
                if (_notEquals) {
                  String _group_4 = patchStepMatcher.group(2);
                  String _group_5 = patchStepMatcher.group(2);
                  int _length_2 = _group_5.length();
                  int _minus_2 = (_length_2 - 1);
                  String _substring_2 = _group_4.substring(1, _minus_2);
                  stepMatchingVariables.set(7, _substring_2);
                } else {
                  String _group_6 = patchStepMatcher.group(2);
                  String _group_7 = patchStepMatcher.group(2);
                  int _length_3 = _group_7.length();
                  int _minus_3 = (_length_3 - 1);
                  String _substring_3 = _group_6.substring(1, _minus_3);
                  stepMatchingVariables.set(6, _substring_3);
                }
              }
              boolean _find_3 = objectFromRepoMatcher.find();
              if (_find_3) {
                String _get_1 = stepMatchingVariables.get(8);
                boolean _notEquals_1 = (!Objects.equal(_get_1, null));
                if (_notEquals_1) {
                  String _group_8 = objectFromRepoMatcher.group(1);
                  String _group_9 = objectFromRepoMatcher.group(1);
                  int _length_4 = _group_9.length();
                  int _minus_4 = (_length_4 - 1);
                  String _substring_4 = _group_8.substring(1, _minus_4);
                  stepMatchingVariables.set(9, _substring_4);
                } else {
                  String _group_10 = objectFromRepoMatcher.group(1);
                  String _group_11 = objectFromRepoMatcher.group(1);
                  int _length_5 = _group_11.length();
                  int _minus_5 = (_length_5 - 1);
                  String _substring_5 = _group_10.substring(1, _minus_5);
                  stepMatchingVariables.set(8, _substring_5);
                }
              }
            }
          }
          int count = 0;
          Set<String> _keySet = methodStructureMap.keySet();
          for (final String key : _keySet) {
            {
              ArrayList<String> methodStrList = new ArrayList<String>();
              for (int listIndex = 0; (listIndex < 10); listIndex++) {
                methodStrList.add(null);
              }
              String _get = stepMatchingVariables.get(9);
              boolean isSingleObjectMethod = Objects.equal(_get, null);
              String _get_1 = stepMatchingVariables.get(2);
              List<String> _get_2 = associationTable.get(_get_1);
              String uri = _get_2.get(count);
              Matcher pathVariableMatcher = pathVariablePattern.matcher(uri);
              boolean isPathVariableNotEMpty = pathVariableMatcher.find();
              String requestBodyVariable = stepMatchingVariables.get(3);
              String patchJson1 = stepMatchingVariables.get(6);
              String patchJson2 = stepMatchingVariables.get(7);
              boolean _isNullOrEmpty = StringExtensions.isNullOrEmpty(requestBodyVariable);
              boolean isReqBodyNotEmpty = (!_isNullOrEmpty);
              LinkedHashMap<String, ArrayList<String>> objects = new LinkedHashMap<String, ArrayList<String>>();
              String initialObjectValue1 = stepMatchingVariables.get(8);
              String initialObjectValue2 = stepMatchingVariables.get(9);
              boolean _isNullOrEmpty_1 = StringExtensions.isNullOrEmpty(initialObjectValue1);
              boolean isInitialObjectValueNotEmpty = (!_isNullOrEmpty_1);
              boolean _and = false;
              boolean _isNullOrEmpty_2 = StringExtensions.isNullOrEmpty(initialObjectValue1);
              boolean _not = (!_isNullOrEmpty_2);
              if (!_not) {
                _and = false;
              } else {
                boolean _isNullOrEmpty_3 = StringExtensions.isNullOrEmpty(initialObjectValue2);
                boolean _not_1 = (!_isNullOrEmpty_3);
                _and = _not_1;
              }
              if (_and) {
                int _indexOf = initialObjectValue1.indexOf("findOne(");
                int _plus_1 = (_indexOf + 8);
                int _indexOf_1 = initialObjectValue1.indexOf(")}");
                final String idName1 = initialObjectValue1.substring(_plus_1, _indexOf_1);
                int _indexOf_2 = initialObjectValue2.indexOf("findOne(");
                int _plus_2 = (_indexOf_2 + 8);
                int _indexOf_3 = initialObjectValue2.indexOf(")}");
                final String idName2 = initialObjectValue2.substring(_plus_2, _indexOf_3);
                int _indexOf_4 = initialObjectValue1.indexOf("#{$");
                int _plus_3 = (_indexOf_4 + 3);
                int _indexOf_5 = initialObjectValue1.indexOf("s.findOne");
                String _substring = initialObjectValue1.substring(_plus_3, _indexOf_5);
                List<String> _asList = Arrays.<String>asList(initialObjectValue1, idName1, patchJson1);
                ArrayList<String> _arrayList = new ArrayList<String>(_asList);
                objects.put(_substring, _arrayList);
                int _indexOf_6 = initialObjectValue2.indexOf("#{$");
                int _plus_4 = (_indexOf_6 + 3);
                int _indexOf_7 = initialObjectValue2.indexOf("s.findOne");
                String _substring_1 = initialObjectValue2.substring(_plus_4, _indexOf_7);
                List<String> _asList_1 = Arrays.<String>asList(initialObjectValue2, idName2, patchJson2);
                ArrayList<String> _arrayList_1 = new ArrayList<String>(_asList_1);
                objects.put(_substring_1, _arrayList_1);
              }
              String[] splitUri = { "", "" };
              if (isPathVariableNotEMpty) {
                String _group = pathVariableMatcher.group(1);
                String _plus_5 = ("\\{" + _group);
                String _plus_6 = (_plus_5 + "\\}");
                String[] _split = uri.split(_plus_6, 2);
                splitUri = _split;
              }
              String _get_3 = stepMatchingVariables.get(4);
              List<String> _get_4 = associationTable.get(_get_3);
              String status = _get_4.get(count);
              String idVal = new String();
              if (isPathVariableNotEMpty) {
                String _group_1 = pathVariableMatcher.group(1);
                List<String> _get_5 = associationTable.get(_group_1);
                String _get_6 = _get_5.get(count);
                idVal = _get_6;
              }
              methodStrList.set(0, key);
              methodStrList.set(1, object);
              methodStrList.set(2, uri);
              String _get_7 = methodStructureMap.get(key);
              methodStrList.set(3, _get_7);
              methodStrList.set(4, status);
              String _get_8 = stepMatchingVariables.get(3);
              boolean _notEquals = (!Objects.equal(_get_8, null));
              if (_notEquals) {
                String _get_9 = stepMatchingVariables.get(3);
                List<String> _get_10 = associationTable.get(_get_9);
                String _get_11 = _get_10.get(count);
                methodStrList.set(5, _get_11);
              }
              String _get_12 = stepMatchingVariables.get(10);
              methodStrList.set(6, _get_12);
              String _get_13 = stepMatchingVariables.get(11);
              List<String> _get_14 = associationTable.get(_get_13);
              String _get_15 = _get_14.get(count);
              methodStrList.set(7, _get_15);
              String _string = Integer.valueOf((count + 1)).toString();
              methodStrMap.put(_string, methodStrList);
              boolean _contains = methodBody.contains((((("ResponseEntity<" + object) + "> ") + key) + "("));
              boolean _not_2 = (!_contains);
              if (_not_2) {
                if (isSingleObjectMethod) {
                  StringConcatenation _builder_1 = new StringConcatenation();
                  _builder_1.append("//");
                  _builder_1.newLine();
                  _builder_1.append("\t");
                  _builder_1.append("@RequestMapping(value=\"");
                  _builder_1.append(uri, "\t");
                  _builder_1.append("\",method=RequestMethod.");
                  String _get_16 = methodStructureMap.get(key);
                  _builder_1.append(_get_16, "\t");
                  _builder_1.append(")");
                  _builder_1.newLineIfNotEmpty();
                  _builder_1.append("\t");
                  _builder_1.append("public ResponseEntity<");
                  _builder_1.append(object, "\t");
                  _builder_1.append("> ");
                  _builder_1.append(key, "\t");
                  _builder_1.append("(@RequestHeader(\"keepAlive\") Boolean keepDbAlive");
                  {
                    if (isPathVariableNotEMpty) {
                      _builder_1.append(", @PathVariable Long ");
                      String _group_2 = pathVariableMatcher.group(1);
                      _builder_1.append(_group_2, "\t");
                    }
                  }
                  {
                    if (isReqBodyNotEmpty) {
                      _builder_1.append(", @RequestBody String ");
                      _builder_1.append(requestBodyVariable, "\t");
                    }
                  }
                  _builder_1.append(") throws Exception{");
                  _builder_1.newLineIfNotEmpty();
                  _builder_1.append("\t\t");
                  _builder_1.append("if (!keepDbAlive) {");
                  _builder_1.newLine();
                  _builder_1.append("\t\t\t");
                  _builder_1.append("setupBackground();");
                  _builder_1.newLine();
                  _builder_1.append("\t\t");
                  _builder_1.append("}");
                  _builder_1.newLine();
                  _builder_1.append("\t\t");
                  _builder_1.newLine();
                  {
                    if (isReqBodyNotEmpty) {
                      _builder_1.append("\t\t");
                      _builder_1.append("JsonNode ");
                      _builder_1.append(requestBodyVariable, "\t\t");
                      _builder_1.append("1 = mapper.readTree(");
                      _builder_1.append(requestBodyVariable, "\t\t");
                      _builder_1.append(");");
                      _builder_1.newLineIfNotEmpty();
                    }
                  }
                  {
                    if ((isPathVariableNotEMpty && isInitialObjectValueNotEmpty)) {
                      _builder_1.append("\t\t");
                      _builder_1.append("Expression expression1 = null;");
                      _builder_1.newLine();
                      _builder_1.append("\t\t");
                      _builder_1.append("if (!keepDbAlive) {");
                      _builder_1.newLine();
                      _builder_1.append("\t\t");
                      _builder_1.append("\t");
                      _builder_1.append("expression1 = spelParser.parseExpression(\"");
                      String _group_3 = pathVariableMatcher.group(1);
                      String _plus_7 = ("(" + _group_3);
                      String _plus_8 = (_plus_7 + ")");
                      String _replace = initialObjectValue1.replace(_plus_8, (("(" + idVal) + ")"));
                      _builder_1.append(_replace, "\t\t\t");
                      _builder_1.append("\", new TemplateParserContext());");
                      _builder_1.newLineIfNotEmpty();
                      _builder_1.append("\t\t");
                      _builder_1.append("} else {");
                      _builder_1.newLine();
                      _builder_1.append("\t\t");
                      _builder_1.append("\t");
                      _builder_1.append("expression1 = spelParser.parseExpression(String.format(\"");
                      String _group_4 = pathVariableMatcher.group(1);
                      String _plus_9 = ("(" + _group_4);
                      String _plus_10 = (_plus_9 + ")");
                      String _replace_1 = initialObjectValue1.replace(_plus_10, "(new Long(%d))");
                      _builder_1.append(_replace_1, "\t\t\t");
                      _builder_1.append("\", ");
                      String _group_5 = pathVariableMatcher.group(1);
                      _builder_1.append(_group_5, "\t\t\t");
                      _builder_1.append("), new TemplateParserContext());");
                      _builder_1.newLineIfNotEmpty();
                      _builder_1.append("\t\t");
                      _builder_1.append("}");
                      _builder_1.newLine();
                      _builder_1.append("\t\t");
                      _builder_1.append(object, "\t\t");
                      _builder_1.append(" _");
                      String _firstLower = StringExtensions.toFirstLower(object);
                      _builder_1.append(_firstLower, "\t\t");
                      _builder_1.append("1 = expression1.getValue(spelContext, ");
                      _builder_1.append(object, "\t\t");
                      _builder_1.append(".class);");
                      _builder_1.newLineIfNotEmpty();
                      _builder_1.append("\t\t");
                      _builder_1.append("JsonNode ");
                      String _firstLower_1 = StringExtensions.toFirstLower(object);
                      _builder_1.append(_firstLower_1, "\t\t");
                      _builder_1.append("JsonNode = mapper.valueToTree(_");
                      String _firstLower_2 = StringExtensions.toFirstLower(object);
                      _builder_1.append(_firstLower_2, "\t\t");
                      _builder_1.append("1);");
                      _builder_1.newLineIfNotEmpty();
                    }
                  }
                  _builder_1.append("\t\t");
                  _builder_1.newLine();
                  {
                    if ((isReqBodyNotEmpty && isInitialObjectValueNotEmpty)) {
                      _builder_1.append("\t\t");
                      _builder_1.append("Iterator<JsonNode> nodeIterator = ");
                      _builder_1.append(requestBodyVariable, "\t\t");
                      _builder_1.append("1.iterator();");
                      _builder_1.newLineIfNotEmpty();
                      _builder_1.append("\t\t");
                      _builder_1.append("while(nodeIterator.hasNext()) {");
                      _builder_1.newLine();
                      _builder_1.append("\t\t");
                      _builder_1.append("\t");
                      _builder_1.append("if(nodeIterator.next() instanceof NullNode) nodeIterator.remove();");
                      _builder_1.newLine();
                      _builder_1.append("\t\t");
                      _builder_1.append("\t");
                      _builder_1.newLine();
                      _builder_1.append("\t\t");
                      _builder_1.append("}");
                      _builder_1.newLine();
                      _builder_1.append("\t\t");
                      _builder_1.newLine();
                      _builder_1.append("\t\t");
                      String _firstLower_3 = StringExtensions.toFirstLower(object);
                      _builder_1.append(_firstLower_3, "\t\t");
                      _builder_1.append("JsonNode = $mergePatch(");
                      String _firstLower_4 = StringExtensions.toFirstLower(object);
                      _builder_1.append(_firstLower_4, "\t\t");
                      _builder_1.append("JsonNode, ");
                      _builder_1.append(requestBodyVariable, "\t\t");
                      _builder_1.append("1.toString());");
                      _builder_1.newLineIfNotEmpty();
                    }
                  }
                  _builder_1.append("\t\t");
                  _builder_1.newLine();
                  _builder_1.append("\t\t");
                  _builder_1.append("Expression expression = spelParser.parseExpression(\"");
                  List<String> _get_17 = associationTable.get(patchJson1);
                  String _get_18 = _get_17.get(count);
                  String _replace_2 = _get_18.replace("\"", "\\\"");
                  _builder_1.append(_replace_2, "\t\t");
                  _builder_1.append("\", new TemplateParserContext());");
                  _builder_1.newLineIfNotEmpty();
                  _builder_1.append("\t\t");
                  _builder_1.append("String expressionResult = expression.getValue(spelContext, String.class);");
                  _builder_1.newLine();
                  {
                    if ((isReqBodyNotEmpty && (!isInitialObjectValueNotEmpty))) {
                      _builder_1.append("\t\t");
                      _builder_1.append("JsonNode mergePatchResult = $mergePatch(");
                      _builder_1.append(requestBodyVariable, "\t\t");
                      _builder_1.append("1, expressionResult);");
                      _builder_1.newLineIfNotEmpty();
                      _builder_1.append("\t\t");
                      _builder_1.append(object, "\t\t");
                      _builder_1.append(" _");
                      String _firstLower_5 = StringExtensions.toFirstLower(object);
                      _builder_1.append(_firstLower_5, "\t\t");
                      _builder_1.append(" = mapper.treeToValue(mergePatchResult, ");
                      _builder_1.append(object, "\t\t");
                      _builder_1.append(".class);");
                      _builder_1.newLineIfNotEmpty();
                      {
                        if (isPathVariableNotEMpty) {
                          _builder_1.append("\t\t");
                          _builder_1.append("_");
                          String _firstLower_6 = StringExtensions.toFirstLower(object);
                          _builder_1.append(_firstLower_6, "\t\t");
                          _builder_1.append(".add(new Link(\"");
                          String _get_19 = splitUri[0];
                          _builder_1.append(_get_19, "\t\t");
                          _builder_1.append("\"+ ");
                          String _group_6 = pathVariableMatcher.group(1);
                          _builder_1.append(_group_6, "\t\t");
                          _builder_1.append(" + \"");
                          String _get_20 = splitUri[1];
                          _builder_1.append(_get_20, "\t\t");
                          _builder_1.append("/\" + _");
                          String _firstLower_7 = StringExtensions.toFirstLower(object);
                          _builder_1.append(_firstLower_7, "\t\t");
                          _builder_1.append(".get_id()));");
                          _builder_1.newLineIfNotEmpty();
                        } else {
                          _builder_1.append("\t\t");
                          _builder_1.append("_");
                          String _firstLower_8 = StringExtensions.toFirstLower(object);
                          _builder_1.append(_firstLower_8, "\t\t");
                          _builder_1.append(".add(new Link(\"");
                          _builder_1.append(uri, "\t\t");
                          _builder_1.append("/\" + _");
                          String _firstLower_9 = StringExtensions.toFirstLower(object);
                          _builder_1.append(_firstLower_9, "\t\t");
                          _builder_1.append(".get_id()));");
                          _builder_1.newLineIfNotEmpty();
                        }
                      }
                    } else {
                      if (isPathVariableNotEMpty) {
                        _builder_1.append("\t\t");
                        _builder_1.append("JsonNode mergePatchResult = $patch(");
                        String _firstLower_10 = StringExtensions.toFirstLower(object);
                        _builder_1.append(_firstLower_10, "\t\t");
                        _builder_1.append("JsonNode, expressionResult);");
                        _builder_1.newLineIfNotEmpty();
                        _builder_1.append("\t\t");
                        _builder_1.append(object, "\t\t");
                        _builder_1.append(" _");
                        String _firstLower_11 = StringExtensions.toFirstLower(object);
                        _builder_1.append(_firstLower_11, "\t\t");
                        _builder_1.append(" = mapper.treeToValue(mergePatchResult, ");
                        _builder_1.append(object, "\t\t");
                        _builder_1.append(".class);");
                        _builder_1.newLineIfNotEmpty();
                      }
                    }
                  }
                  _builder_1.append("\t\t");
                  _builder_1.newLine();
                  _builder_1.append("\t\t");
                  String _firstLower_12 = StringExtensions.toFirstLower(object);
                  _builder_1.append(_firstLower_12, "\t\t");
                  _builder_1.append("Repo.save(_");
                  String _firstLower_13 = StringExtensions.toFirstLower(object);
                  _builder_1.append(_firstLower_13, "\t\t");
                  _builder_1.append(");");
                  _builder_1.newLineIfNotEmpty();
                  _builder_1.append("\t\t");
                  _builder_1.newLine();
                  _builder_1.append("\t\t");
                  _builder_1.append("HttpHeaders headers = new HttpHeaders();");
                  _builder_1.newLine();
                  {
                    if ((isReqBodyNotEmpty && (!isPathVariableNotEMpty))) {
                      _builder_1.append("\t\t");
                      _builder_1.append("headers.add(\"Location\", _");
                      String _firstLower_14 = StringExtensions.toFirstLower(object);
                      _builder_1.append(_firstLower_14, "\t\t");
                      _builder_1.append(".getId().getHref());");
                      _builder_1.newLineIfNotEmpty();
                      _builder_1.append("\t\t");
                      _builder_1.newLine();
                    }
                  }
                  _builder_1.append("\t\t");
                  _builder_1.append("return new ResponseEntity<");
                  _builder_1.append(object, "\t\t");
                  _builder_1.append(">(_");
                  String _firstLower_15 = StringExtensions.toFirstLower(object);
                  _builder_1.append(_firstLower_15, "\t\t");
                  _builder_1.append(", headers, HttpStatus.valueOf(");
                  _builder_1.append(status, "\t\t");
                  _builder_1.append("));");
                  _builder_1.newLineIfNotEmpty();
                  _builder_1.append("\t");
                  _builder_1.append("}");
                  _builder_1.newLine();
                  _builder_1.append("\t");
                  _builder_1.newLine();
                  String _plus_11 = (methodBody + _builder_1);
                  methodBody = _plus_11;
                } else {
                  Set<String> _keySet_1 = objects.keySet();
                  List<String> objList = new ArrayList<String>(_keySet_1);
                  List<String> _reverse = ListExtensions.<String>reverse(objList);
                  objList = _reverse;
                  StringConcatenation _builder_2 = new StringConcatenation();
                  _builder_2.append("//");
                  _builder_2.newLine();
                  _builder_2.append("\t");
                  _builder_2.append("@RequestMapping(value=\"");
                  _builder_2.append(uri, "\t");
                  _builder_2.append("\",method=RequestMethod.");
                  String _get_21 = methodStructureMap.get(key);
                  _builder_2.append(_get_21, "\t");
                  _builder_2.append(")");
                  _builder_2.newLineIfNotEmpty();
                  _builder_2.append("\t");
                  _builder_2.append("public ResponseEntity<");
                  _builder_2.append(object, "\t");
                  _builder_2.append("> ");
                  _builder_2.append(key, "\t");
                  _builder_2.append("(@RequestHeader(\"keepAlive\") Boolean keepDbAlive");
                  {
                    if (isPathVariableNotEMpty) {
                      _builder_2.append(", @PathVariable Long ");
                      String _group_7 = pathVariableMatcher.group(1);
                      _builder_2.append(_group_7, "\t");
                    }
                  }
                  {
                    boolean _find = pathVariableMatcher.find();
                    if (_find) {
                      _builder_2.append(", @PathVariable Long ");
                      String _group_8 = pathVariableMatcher.group(1);
                      _builder_2.append(_group_8, "\t");
                    }
                  }
                  _builder_2.append(") throws Exception{");
                  _builder_2.newLineIfNotEmpty();
                  _builder_2.append("\t\t");
                  _builder_2.append("if (!keepDbAlive) {");
                  _builder_2.newLine();
                  _builder_2.append("\t\t\t");
                  _builder_2.append("setupBackground();");
                  _builder_2.newLine();
                  _builder_2.append("\t\t");
                  _builder_2.append("}");
                  _builder_2.newLine();
                  _builder_2.append("\t\t");
                  _builder_2.newLine();
                  _builder_2.append("\t\t");
                  _builder_2.append("Expression expression1 = null;");
                  _builder_2.newLine();
                  {
                    for(final String obj : objList) {
                      _builder_2.append("\t\t");
                      _builder_2.append("if (!keepDbAlive) {");
                      _builder_2.newLine();
                      _builder_2.append("\t\t");
                      _builder_2.append("\t");
                      _builder_2.append("expression1 = spelParser.parseExpression(\"");
                      ArrayList<String> _get_22 = objects.get(obj);
                      String _get_23 = _get_22.get(0);
                      ArrayList<String> _get_24 = objects.get(obj);
                      String _get_25 = _get_24.get(1);
                      String _plus_12 = ("(" + _get_25);
                      String _plus_13 = (_plus_12 + ")");
                      ArrayList<String> _get_26 = objects.get(obj);
                      String _get_27 = _get_26.get(1);
                      List<String> _get_28 = associationTable.get(_get_27);
                      String _get_29 = _get_28.get(count);
                      String _plus_14 = ("(" + _get_29);
                      String _plus_15 = (_plus_14 + ")");
                      String _replace_3 = _get_23.replace(_plus_13, _plus_15);
                      _builder_2.append(_replace_3, "\t\t\t");
                      _builder_2.append("\", new TemplateParserContext());");
                      _builder_2.newLineIfNotEmpty();
                      _builder_2.append("\t\t");
                      _builder_2.append("} else {");
                      _builder_2.newLine();
                      _builder_2.append("\t\t");
                      _builder_2.append("\t");
                      _builder_2.append("expression1 = spelParser.parseExpression(String.format(\"");
                      ArrayList<String> _get_30 = objects.get(obj);
                      String _get_31 = _get_30.get(0);
                      ArrayList<String> _get_32 = objects.get(obj);
                      String _get_33 = _get_32.get(1);
                      String _plus_16 = ("(" + _get_33);
                      String _plus_17 = (_plus_16 + ")");
                      String _replace_4 = _get_31.replace(_plus_17, "(new Long(%d))");
                      _builder_2.append(_replace_4, "\t\t\t");
                      _builder_2.append("\", ");
                      ArrayList<String> _get_34 = objects.get(obj);
                      String _get_35 = _get_34.get(1);
                      _builder_2.append(_get_35, "\t\t\t");
                      _builder_2.append("), new TemplateParserContext());");
                      _builder_2.newLineIfNotEmpty();
                      _builder_2.append("\t\t");
                      _builder_2.append("}");
                      _builder_2.newLine();
                      _builder_2.append("\t\t");
                      _builder_2.append(obj, "\t\t");
                      _builder_2.append(" _");
                      String _firstLower_16 = StringExtensions.toFirstLower(obj);
                      _builder_2.append(_firstLower_16, "\t\t");
                      _builder_2.append("1 = expression1.getValue(spelContext, ");
                      _builder_2.append(obj, "\t\t");
                      _builder_2.append(".class);");
                      _builder_2.newLineIfNotEmpty();
                      _builder_2.append("\t\t");
                      _builder_2.append("JsonNode ");
                      String _firstLower_17 = StringExtensions.toFirstLower(obj);
                      _builder_2.append(_firstLower_17, "\t\t");
                      _builder_2.append("JsonNode = mapper.valueToTree(_");
                      String _firstLower_18 = StringExtensions.toFirstLower(obj);
                      _builder_2.append(_firstLower_18, "\t\t");
                      _builder_2.append("1);");
                      _builder_2.newLineIfNotEmpty();
                      _builder_2.append("\t\t");
                      _builder_2.newLine();
                      _builder_2.append("\t\t");
                      ArrayList<String> _get_36 = objects.get(obj);
                      String _get_37 = _get_36.get(2);
                      List<String> _get_38 = associationTable.get(_get_37);
                      String _get_39 = _get_38.get(count);
                      Matcher objMatcher = objectFromRepoVariablePattern.matcher(_get_39);
                      _builder_2.newLineIfNotEmpty();
                      {
                        boolean _find_1 = objMatcher.find();
                        if (_find_1) {
                          _builder_2.append("\t\t");
                          _builder_2.append("Expression expression");
                          _builder_2.append(obj, "\t\t");
                          _builder_2.append(" = spelParser.parseExpression(String.format(\"");
                          ArrayList<String> _get_40 = objects.get(obj);
                          String _get_41 = _get_40.get(2);
                          List<String> _get_42 = associationTable.get(_get_41);
                          String _get_43 = _get_42.get(count);
                          String _replace_5 = _get_43.replace("\"", "\\\"");
                          String _group_9 = objMatcher.group(1);
                          String _plus_18 = ("(" + _group_9);
                          String _plus_19 = (_plus_18 + ")");
                          String _replace_6 = _replace_5.replace(_plus_19, "(new Long(%d))");
                          _builder_2.append(_replace_6, "\t\t");
                          _builder_2.append("\",");
                          String _group_10 = pathVariableMatcher.group(1);
                          _builder_2.append(_group_10, "\t\t");
                          _builder_2.append("), new TemplateParserContext());");
                          _builder_2.newLineIfNotEmpty();
                        } else {
                          _builder_2.append("\t\t");
                          _builder_2.append("Expression expression");
                          _builder_2.append(obj, "\t\t");
                          _builder_2.append(" = spelParser.parseExpression(\"");
                          ArrayList<String> _get_44 = objects.get(obj);
                          String _get_45 = _get_44.get(2);
                          List<String> _get_46 = associationTable.get(_get_45);
                          String _get_47 = _get_46.get(count);
                          String _replace_7 = _get_47.replace("\"", "\\\"");
                          _builder_2.append(_replace_7, "\t\t");
                          _builder_2.append("\", new TemplateParserContext());");
                          _builder_2.newLineIfNotEmpty();
                        }
                      }
                      _builder_2.append("\t\t");
                      _builder_2.append("String expressionResult");
                      _builder_2.append(obj, "\t\t");
                      _builder_2.append(" = expression");
                      _builder_2.append(obj, "\t\t");
                      _builder_2.append(".getValue(spelContext, String.class);");
                      _builder_2.newLineIfNotEmpty();
                      _builder_2.append("\t\t");
                      _builder_2.append("JsonNode mergePatchResult");
                      _builder_2.append(obj, "\t\t");
                      _builder_2.append(" = $patch(");
                      String _firstLower_19 = StringExtensions.toFirstLower(obj);
                      _builder_2.append(_firstLower_19, "\t\t");
                      _builder_2.append("JsonNode, expressionResult");
                      _builder_2.append(obj, "\t\t");
                      _builder_2.append(");");
                      _builder_2.newLineIfNotEmpty();
                      _builder_2.append("\t\t");
                      _builder_2.append(obj, "\t\t");
                      _builder_2.append(" _");
                      String _firstLower_20 = StringExtensions.toFirstLower(obj);
                      _builder_2.append(_firstLower_20, "\t\t");
                      _builder_2.append(" = mapper.treeToValue(mergePatchResult");
                      _builder_2.append(obj, "\t\t");
                      _builder_2.append(", ");
                      _builder_2.append(obj, "\t\t");
                      _builder_2.append(".class);");
                      _builder_2.newLineIfNotEmpty();
                      _builder_2.append("\t\t");
                      _builder_2.newLine();
                      _builder_2.append("\t\t");
                      String _firstLower_21 = StringExtensions.toFirstLower(obj);
                      _builder_2.append(_firstLower_21, "\t\t");
                      _builder_2.append("Repo.save(_");
                      String _firstLower_22 = StringExtensions.toFirstLower(obj);
                      _builder_2.append(_firstLower_22, "\t\t");
                      _builder_2.append(");");
                      _builder_2.newLineIfNotEmpty();
                    }
                  }
                  _builder_2.append("\t\t");
                  _builder_2.newLine();
                  _builder_2.append("\t\t");
                  _builder_2.append("HttpHeaders headers = new HttpHeaders();");
                  _builder_2.newLine();
                  _builder_2.append("\t\t");
                  _builder_2.append("return new ResponseEntity<");
                  _builder_2.append(object, "\t\t");
                  _builder_2.append(">(_");
                  String _firstLower_23 = StringExtensions.toFirstLower(object);
                  _builder_2.append(_firstLower_23, "\t\t");
                  _builder_2.append(", headers, HttpStatus.valueOf(");
                  _builder_2.append(status, "\t\t");
                  _builder_2.append("));");
                  _builder_2.newLineIfNotEmpty();
                  _builder_2.append("\t");
                  _builder_2.append("}");
                  _builder_2.newLine();
                  _builder_2.append("\t");
                  _builder_2.newLine();
                  String _plus_20 = (methodBody + _builder_2);
                  methodBody = _plus_20;
                }
              }
              count = (count + 1);
            }
          }
          String _title_2 = scOutline.getTitle();
          this.methods.put(_title_2, methodStrMap);
        }
      }
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("package com.example;");
      _builder_1.newLine();
      _builder_1.newLine();
      _builder_1.append("import java.util.Iterator;");
      _builder_1.newLine();
      _builder_1.newLine();
      _builder_1.append("import org.springframework.beans.factory.annotation.Autowired;");
      _builder_1.newLine();
      _builder_1.append("import org.springframework.expression.*;");
      _builder_1.newLine();
      _builder_1.append("import org.springframework.expression.common.TemplateParserContext;");
      _builder_1.newLine();
      _builder_1.append("import org.springframework.expression.spel.standard.SpelExpressionParser;");
      _builder_1.newLine();
      _builder_1.append("import org.springframework.expression.spel.support.StandardEvaluationContext;");
      _builder_1.newLine();
      _builder_1.append("import org.springframework.hateoas.Link;");
      _builder_1.newLine();
      _builder_1.append("import org.springframework.http.*;");
      _builder_1.newLine();
      _builder_1.append("import org.springframework.web.bind.annotation.*;");
      _builder_1.newLine();
      _builder_1.append("import org.springframework.stereotype.Component;");
      _builder_1.newLine();
      _builder_1.append("import com.example.models.*;");
      _builder_1.newLine();
      _builder_1.append("import com.fasterxml.jackson.databind.*;");
      _builder_1.newLine();
      _builder_1.append("import com.fasterxml.jackson.databind.node.NullNode;");
      _builder_1.newLine();
      _builder_1.append("import com.github.fge.jsonpatch.JsonPatch;");
      _builder_1.newLine();
      _builder_1.append("import com.github.fge.jsonpatch.mergepatch.JsonMergePatch;");
      _builder_1.newLine();
      _builder_1.newLine();
      _builder_1.append("@Component");
      _builder_1.newLine();
      _builder_1.append("public class Skeleton {");
      _builder_1.newLine();
      {
        Set<String> _keySet_1 = typeMap.keySet();
        for(final String key_1 : _keySet_1) {
          _builder_1.append("\t");
          _builder_1.append("@Autowired");
          _builder_1.newLine();
          _builder_1.append("\t");
          _builder_1.append("Mock");
          Pair<String, String> _get = typeMap.get(key_1);
          String _value = _get.getValue();
          _builder_1.append(_value, "\t");
          _builder_1.append("Repository ");
          _builder_1.append(key_1, "\t");
          _builder_1.append(";");
          _builder_1.newLineIfNotEmpty();
          _builder_1.newLine();
        }
      }
      _builder_1.append("\t");
      _builder_1.append("ObjectMapper mapper = new ObjectMapper().findAndRegisterModules();");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("StandardEvaluationContext spelContext;");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("ExpressionParser spelParser;");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("class LocalSpelContext {");
      _builder_1.newLine();
      {
        Set<String> _keySet_2 = typeMap.keySet();
        for(final String key_2 : _keySet_2) {
          _builder_1.append("\t\t");
          _builder_1.append("public Mock");
          Pair<String, String> _get_1 = typeMap.get(key_2);
          String _value_1 = _get_1.getValue();
          _builder_1.append(_value_1, "\t\t");
          _builder_1.append("Repository $");
          Pair<String, String> _get_2 = typeMap.get(key_2);
          String _value_2 = _get_2.getValue();
          _builder_1.append(_value_2, "\t\t");
          _builder_1.append("s = ");
          _builder_1.append(key_2, "\t\t");
          _builder_1.append(";");
          _builder_1.newLineIfNotEmpty();
        }
      }
      _builder_1.append("\t\t");
      _builder_1.append("public String $toJson(Object o) throws Exception {");
      _builder_1.newLine();
      _builder_1.append("\t\t\t");
      _builder_1.append("return mapper.writeValueAsString(o);");
      _builder_1.newLine();
      _builder_1.append("\t\t");
      _builder_1.append("}\t\t");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("}");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("public JsonNode $mergePatch(JsonNode obj, String json) throws Exception {");
      _builder_1.newLine();
      _builder_1.append("\t\t");
      _builder_1.append("JsonMergePatch mp = mapper.readValue(json, JsonMergePatch.class);");
      _builder_1.newLine();
      _builder_1.append("\t\t");
      _builder_1.append("return mp.apply(obj);");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("}");
      _builder_1.newLine();
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("public JsonNode $patch(JsonNode obj, String json) throws Exception {");
      _builder_1.newLine();
      _builder_1.append("\t\t");
      _builder_1.append("JsonPatch mp = mapper.readValue(json, JsonPatch.class);");
      _builder_1.newLine();
      _builder_1.append("\t\t");
      _builder_1.append("return mp.apply(obj);");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("}");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.newLine();
      String completeBody = _builder_1.toString();
      StringConcatenation _builder_2 = new StringConcatenation();
      String fixtureString = _builder_2.toString();
      Set<String> _keySet_3 = typeMap.keySet();
      for (final String key_3 : _keySet_3) {
        StringConcatenation _builder_3 = new StringConcatenation();
        _builder_3.append("//");
        _builder_3.newLine();
        _builder_3.append("\t\t");
        _builder_3.append("for (String json: ");
        Pair<String, String> _get_3 = typeMap.get(key_3);
        String _key = _get_3.getKey();
        _builder_3.append(_key, "\t\t");
        _builder_3.append(") {");
        _builder_3.newLineIfNotEmpty();
        _builder_3.append("\t\t\t");
        _builder_3.append("Expression expression = spelParser.parseExpression(json, new TemplateParserContext());");
        _builder_3.newLine();
        _builder_3.append("\t\t\t");
        _builder_3.append("String rewrittenJson = expression.getValue(spelContext, String.class);");
        _builder_3.newLine();
        _builder_3.append("\t\t\t");
        _builder_3.append(key_3, "\t\t\t");
        _builder_3.append(".save(mapper.readValue(rewrittenJson, ");
        Pair<String, String> _get_4 = typeMap.get(key_3);
        String _value_3 = _get_4.getValue();
        _builder_3.append(_value_3, "\t\t\t");
        _builder_3.append(".class));");
        _builder_3.newLineIfNotEmpty();
        _builder_3.append("\t\t");
        _builder_3.append("}");
        _builder_3.newLine();
        String _plus_1 = (fixtureString + _builder_3);
        fixtureString = _plus_1;
      }
      StringConcatenation _builder_4 = new StringConcatenation();
      _builder_4.append("//");
      _builder_4.newLine();
      _builder_4.append("\t");
      _builder_4.append("@RequestMapping(\"/initialize\")");
      _builder_4.newLine();
      _builder_4.append("\t");
      _builder_4.append("public void setupBackground() throws Exception {\t\t");
      _builder_4.newLine();
      _builder_4.append("\t\t");
      _builder_4.append("spelContext = new StandardEvaluationContext(new LocalSpelContext());");
      _builder_4.newLine();
      _builder_4.append("\t\t");
      _builder_4.append("spelParser = new SpelExpressionParser();");
      _builder_4.newLine();
      _builder_4.append("\t\t");
      _builder_4.append("spelContext.registerFunction(\"$toJson\", LocalSpelContext.class.getDeclaredMethod(\"$toJson\", new Class[] { Object.class }));");
      _builder_4.newLine();
      String _plus_2 = ((completeBody + fixtures) + _builder_4);
      String _plus_3 = (_plus_2 + fixtureString);
      StringConcatenation _builder_5 = new StringConcatenation();
      _builder_5.append("//");
      _builder_5.newLine();
      _builder_5.append("\t");
      _builder_5.append("}");
      _builder_5.newLine();
      String _plus_4 = (_plus_3 + _builder_5);
      String _plus_5 = (_plus_4 + methodBody);
      StringConcatenation _builder_6 = new StringConcatenation();
      _builder_6.append("}");
      _builder_6.newLine();
      _xblockexpression = (_plus_5 + _builder_6);
    }
    return _xblockexpression;
  }
  
  public String generateHelper(final Feature feature) {
    String _xblockexpression = null;
    {
      LinkedHashMap<String, Pair<String, String>> typeMap = new LinkedHashMap<String, Pair<String, String>>();
      String fixtures = new String();
      Background _background = feature.getBackground();
      EList<Step> _steps = _background.getSteps();
      for (final Step step : _steps) {
        EList<Table> _tables = step.getTables();
        for (final Table table : _tables) {
          {
            String _description = step.getDescription();
            String _description_1 = step.getDescription();
            int _indexOf = _description_1.indexOf("following $");
            int _length = "following $".length();
            int _plus = (_indexOf + _length);
            String type = _description.substring(_plus);
            int _length_1 = type.length();
            int _minus = (_length_1 - 1);
            String _substring = type.substring(0, _minus);
            type = _substring;
            String _firstLower = StringExtensions.toFirstLower(type);
            String _plus_1 = ((fixtures + "\tString[] ") + _firstLower);
            String _plus_2 = (_plus_1 + "Fixtures = {\n");
            fixtures = _plus_2;
            String _firstLower_1 = StringExtensions.toFirstLower(type);
            String _plus_3 = (_firstLower_1 + "Repo");
            String _firstLower_2 = StringExtensions.toFirstLower(type);
            String _plus_4 = (_firstLower_2 + "Fixtures");
            int _length_2 = type.length();
            String _substring_1 = type.substring(0, _length_2);
            Pair<String, String> _pair = new Pair<String, String>(_plus_4, _substring_1);
            typeMap.put(_plus_3, _pair);
            EList<String> _rows = table.getRows();
            String titleRow = _rows.get(0);
            String[] titleArray = titleRow.split("\\|", (-1));
            final String[] _converted_titleArray = (String[])titleArray;
            final String[] _converted_titleArray_1 = (String[])titleArray;
            int _size = ((List<String>)Conversions.doWrapArray(_converted_titleArray_1)).size();
            int _minus_1 = (_size - 1);
            List<String> _subList = ((List<String>)Conversions.doWrapArray(_converted_titleArray)).subList(1, _minus_1);
            titleArray = ((String[])Conversions.unwrapArray(_subList, String.class));
            EList<String> _rows_1 = table.getRows();
            EList<String> _rows_2 = table.getRows();
            int _size_1 = _rows_2.size();
            List<String> _subList_1 = _rows_1.subList(1, _size_1);
            for (final String valueRow : _subList_1) {
              {
                String[] valueArray = valueRow.split("\\|", (-1));
                final String[] _converted_valueArray = (String[])valueArray;
                final String[] _converted_valueArray_1 = (String[])valueArray;
                int _size_2 = ((List<String>)Conversions.doWrapArray(_converted_valueArray_1)).size();
                int _minus_2 = (_size_2 - 1);
                List<String> _subList_2 = ((List<String>)Conversions.doWrapArray(_converted_valueArray)).subList(1, _minus_2);
                valueArray = ((String[])Conversions.unwrapArray(_subList_2, String.class));
                boolean firstIteration = true;
                fixtures = (fixtures + "\t\t\"{");
                for (final String item : titleArray) {
                  {
                    final String[] _converted_titleArray_2 = (String[])titleArray;
                    int _indexOf_1 = ((List<String>)Conversions.doWrapArray(_converted_titleArray_2)).indexOf(item);
                    String _get = valueArray[_indexOf_1];
                    String value = _get.trim();
                    String _xifexpression = null;
                    boolean _startsWith = value.startsWith("#{$");
                    if (_startsWith) {
                      _xifexpression = "%s";
                    } else {
                      _xifexpression = "\\\"%s\\\"";
                    }
                    String strFormat = ("%s\"%s\\\":" + _xifexpression);
                    String _xifexpression_1 = null;
                    if (firstIteration) {
                      _xifexpression_1 = "\\";
                    } else {
                      _xifexpression_1 = ",\\";
                    }
                    String _trim = item.trim();
                    String _format = String.format(strFormat, _xifexpression_1, _trim, value);
                    String _plus_5 = (fixtures + _format);
                    fixtures = _plus_5;
                    firstIteration = false;
                  }
                }
                fixtures = (fixtures + "}\",\n");
              }
            }
            fixtures = (fixtures + "\t};\n");
          }
        }
      }
      Pattern phPattern = Pattern.compile("<(\\w+)>");
      Pattern tableHeaderPattern = Pattern.compile("(\\w+)");
      Pattern whenStepPattern = Pattern.compile(".+?\\bcalls?\\s+(\\\'\\w+\\\'|<\\w+>)\\s+using\\s+(\\\'\\w+\\\'|<\\w+>)\\s+on\\s+(\\\'\\w+\\\'|<\\w+>)(?:\\s+with\\s+(\\\'\\w+\\\'|<\\w+>))?");
      StringConcatenation _builder = new StringConcatenation();
      String methodBody = _builder.toString();
      EList<EObject> _scenarios = feature.getScenarios();
      for (final EObject scenario : _scenarios) {
        if ((scenario instanceof ScenarioOutline)) {
          LinkedHashMap<String, String> methodStructureMap = new LinkedHashMap<String, String>();
          String _title = ((ScenarioOutline)scenario).getTitle();
          String _title_1 = ((ScenarioOutline)scenario).getTitle();
          int _lastIndexOf = _title_1.lastIndexOf(" ");
          int _plus = (_lastIndexOf + 1);
          String object = _title.substring(_plus);
          LinkedListMultimap<String, String> associationTable = LinkedListMultimap.<String, String>create();
          ArrayList<String> variables = new ArrayList<String>();
          ScenarioOutline scOutline = ((ScenarioOutline) scenario);
          Examples _examples = scOutline.getExamples();
          Table _table = _examples.getTable();
          EList<String> _rows = _table.getRows();
          String header = _rows.get(0);
          Matcher headerMatcher = tableHeaderPattern.matcher(header);
          while (headerMatcher.find()) {
            String _group = headerMatcher.group(1);
            variables.add(_group);
          }
          InputOutput.<ArrayList<String>>println(variables);
          boolean firstTime = true;
          Examples _examples_1 = scOutline.getExamples();
          Table _table_1 = _examples_1.getTable();
          EList<String> _rows_1 = _table_1.getRows();
          for (final String row : _rows_1) {
            {
              if ((!firstTime)) {
                StringTokenizer tokenizer = new StringTokenizer(row, "|");
                int pos = 0;
                while (tokenizer.hasMoreTokens()) {
                  int _size = variables.size();
                  boolean _lessThan = (pos < _size);
                  if (_lessThan) {
                    int _plusPlus = pos++;
                    String _get = variables.get(_plusPlus);
                    String _nextToken = tokenizer.nextToken();
                    String _trim = _nextToken.trim();
                    associationTable.put(_get, _trim);
                  } else {
                    tokenizer.nextToken();
                  }
                }
              }
              firstTime = false;
            }
          }
          InputOutput.<LinkedListMultimap<String, String>>println(associationTable);
          EList<Step> _steps_1 = scOutline.getSteps();
          for (final Step step_1 : _steps_1) {
            {
              String _description = step_1.getDescription();
              Matcher phs = phPattern.matcher(_description);
              while (phs.find()) {
                String _group = phs.group(1);
                String _plus_1 = ("PH: " + _group);
                InputOutput.<String>println(_plus_1);
              }
            }
          }
          LinkedList<String> stepMatchingVariables = new LinkedList<String>();
          while ((stepMatchingVariables.size() < 4)) {
            stepMatchingVariables.add(null);
          }
          EList<Step> _steps_2 = scOutline.getSteps();
          for (final Step step_2 : _steps_2) {
            {
              Examples _examples_2 = scOutline.getExamples();
              Table _table_2 = _examples_2.getTable();
              EList<String> _rows_2 = _table_2.getRows();
              int _size = _rows_2.size();
              int exampleRowSIze = (_size - 1);
              String _description = step_2.getDescription();
              Matcher whenStepMatcher = whenStepPattern.matcher(_description);
              while (whenStepMatcher.find()) {
                boolean _and = false;
                boolean _and_1 = false;
                String _group = whenStepMatcher.group(1);
                boolean _notEquals = (!Objects.equal(_group, null));
                if (!_notEquals) {
                  _and_1 = false;
                } else {
                  String _group_1 = whenStepMatcher.group(2);
                  boolean _notEquals_1 = (!Objects.equal(_group_1, null));
                  _and_1 = _notEquals_1;
                }
                if (!_and_1) {
                  _and = false;
                } else {
                  String _group_2 = whenStepMatcher.group(3);
                  boolean _notEquals_2 = (!Objects.equal(_group_2, null));
                  _and = _notEquals_2;
                }
                if (_and) {
                  String _group_3 = whenStepMatcher.group(1);
                  String _group_4 = whenStepMatcher.group(1);
                  int _length = _group_4.length();
                  int _minus = (_length - 1);
                  String _substring = _group_3.substring(1, _minus);
                  stepMatchingVariables.set(0, _substring);
                  String _group_5 = whenStepMatcher.group(2);
                  String _group_6 = whenStepMatcher.group(2);
                  int _length_1 = _group_6.length();
                  int _minus_1 = (_length_1 - 1);
                  String _substring_1 = _group_5.substring(1, _minus_1);
                  stepMatchingVariables.set(1, _substring_1);
                  String _group_7 = whenStepMatcher.group(3);
                  String _group_8 = whenStepMatcher.group(3);
                  int _length_2 = _group_8.length();
                  int _minus_2 = (_length_2 - 1);
                  String _substring_2 = _group_7.substring(1, _minus_2);
                  stepMatchingVariables.set(2, _substring_2);
                  String _group_9 = whenStepMatcher.group(4);
                  boolean _notEquals_3 = (!Objects.equal(_group_9, null));
                  if (_notEquals_3) {
                    String _group_10 = whenStepMatcher.group(4);
                    String _group_11 = whenStepMatcher.group(4);
                    int _length_3 = _group_11.length();
                    int _minus_3 = (_length_3 - 1);
                    String _substring_3 = _group_10.substring(1, _minus_3);
                    stepMatchingVariables.set(3, _substring_3);
                  }
                  boolean _and_2 = false;
                  String _group_12 = whenStepMatcher.group(1);
                  boolean _startsWith = _group_12.startsWith("<");
                  boolean _not = (!_startsWith);
                  if (!_not) {
                    _and_2 = false;
                  } else {
                    String _group_13 = whenStepMatcher.group(2);
                    boolean _startsWith_1 = _group_13.startsWith("<");
                    boolean _not_1 = (!_startsWith_1);
                    _and_2 = _not_1;
                  }
                  if (_and_2) {
                    String _group_14 = whenStepMatcher.group(1);
                    String _group_15 = whenStepMatcher.group(1);
                    int _length_4 = _group_15.length();
                    int _minus_4 = (_length_4 - 1);
                    String _substring_4 = _group_14.substring(1, _minus_4);
                    String _group_16 = whenStepMatcher.group(2);
                    String _group_17 = whenStepMatcher.group(2);
                    int _length_5 = _group_17.length();
                    int _minus_5 = (_length_5 - 1);
                    String _substring_5 = _group_16.substring(1, _minus_5);
                    methodStructureMap.put(_substring_4, _substring_5);
                  } else {
                    boolean _and_3 = false;
                    String _group_18 = whenStepMatcher.group(1);
                    boolean _startsWith_2 = _group_18.startsWith("<");
                    if (!_startsWith_2) {
                      _and_3 = false;
                    } else {
                      String _group_19 = whenStepMatcher.group(2);
                      boolean _startsWith_3 = _group_19.startsWith("<");
                      boolean _not_2 = (!_startsWith_3);
                      _and_3 = _not_2;
                    }
                    if (_and_3) {
                      for (int count = 0; (count < exampleRowSIze); count++) {
                        String _group_20 = whenStepMatcher.group(1);
                        String _group_21 = whenStepMatcher.group(1);
                        int _length_6 = _group_21.length();
                        int _minus_6 = (_length_6 - 1);
                        String _substring_6 = _group_20.substring(1, _minus_6);
                        List<String> _get = associationTable.get(_substring_6);
                        String _get_1 = _get.get(count);
                        String _group_22 = whenStepMatcher.group(2);
                        String _group_23 = whenStepMatcher.group(2);
                        int _length_7 = _group_23.length();
                        int _minus_7 = (_length_7 - 1);
                        String _substring_7 = _group_22.substring(1, _minus_7);
                        methodStructureMap.put(_get_1, _substring_7);
                      }
                    } else {
                      boolean _and_4 = false;
                      String _group_20 = whenStepMatcher.group(1);
                      boolean _startsWith_4 = _group_20.startsWith("<");
                      boolean _not_3 = (!_startsWith_4);
                      if (!_not_3) {
                        _and_4 = false;
                      } else {
                        String _group_21 = whenStepMatcher.group(2);
                        boolean _startsWith_5 = _group_21.startsWith("<");
                        _and_4 = _startsWith_5;
                      }
                      if (_and_4) {
                        for (int count = 0; (count < exampleRowSIze); count++) {
                          String _group_22 = whenStepMatcher.group(1);
                          String _group_23 = whenStepMatcher.group(1);
                          int _length_6 = _group_23.length();
                          int _minus_6 = (_length_6 - 1);
                          String _substring_6 = _group_22.substring(1, _minus_6);
                          String _group_24 = whenStepMatcher.group(2);
                          String _group_25 = whenStepMatcher.group(2);
                          int _length_7 = _group_25.length();
                          int _minus_7 = (_length_7 - 1);
                          String _substring_7 = _group_24.substring(1, _minus_7);
                          List<String> _get = associationTable.get(_substring_7);
                          String _get_1 = _get.get(count);
                          methodStructureMap.put(_substring_6, _get_1);
                        }
                      } else {
                        boolean _and_5 = false;
                        String _group_22 = whenStepMatcher.group(1);
                        boolean _startsWith_6 = _group_22.startsWith("<");
                        if (!_startsWith_6) {
                          _and_5 = false;
                        } else {
                          String _group_23 = whenStepMatcher.group(2);
                          boolean _startsWith_7 = _group_23.startsWith("<");
                          _and_5 = _startsWith_7;
                        }
                        if (_and_5) {
                          for (int count = 0; (count < exampleRowSIze); count++) {
                            String _group_24 = whenStepMatcher.group(1);
                            String _group_25 = whenStepMatcher.group(1);
                            int _length_6 = _group_25.length();
                            int _minus_6 = (_length_6 - 1);
                            String _substring_6 = _group_24.substring(1, _minus_6);
                            List<String> _get = associationTable.get(_substring_6);
                            String _get_1 = _get.get(count);
                            String _group_26 = whenStepMatcher.group(2);
                            String _group_27 = whenStepMatcher.group(2);
                            int _length_7 = _group_27.length();
                            int _minus_7 = (_length_7 - 1);
                            String _substring_7 = _group_26.substring(1, _minus_7);
                            List<String> _get_2 = associationTable.get(_substring_7);
                            String _get_3 = _get_2.get(count);
                            methodStructureMap.put(_get_1, _get_3);
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
          int count = 0;
          Set<String> _keySet = methodStructureMap.keySet();
          for (final String key : _keySet) {
            {
              String requestBodyVariable = stepMatchingVariables.get(3);
              boolean _isNullOrEmpty = StringExtensions.isNullOrEmpty(requestBodyVariable);
              boolean isReqBodyNotEmpty = (!_isNullOrEmpty);
              if (isReqBodyNotEmpty) {
                StringConcatenation _builder_1 = new StringConcatenation();
                _builder_1.append("//");
                _builder_1.newLine();
                _builder_1.append("\t");
                _builder_1.append("public ");
                _builder_1.append(object, "\t");
                _builder_1.append(" get");
                String _firstUpper = StringExtensions.toFirstUpper(key);
                _builder_1.append(_firstUpper, "\t");
                _builder_1.append("Data() throws Exception{");
                _builder_1.newLineIfNotEmpty();
                _builder_1.append("\t\t");
                _builder_1.append("Expression expression = spelParser.parseExpression(\"");
                List<String> _get = associationTable.get(requestBodyVariable);
                String _get_1 = _get.get(count);
                String _replace = _get_1.replace("\"", "\\\"");
                _builder_1.append(_replace, "\t\t");
                _builder_1.append("\", new TemplateParserContext());");
                _builder_1.newLineIfNotEmpty();
                _builder_1.append("\t\t");
                _builder_1.append("String expressionResult = expression.getValue(spelContext, String.class);");
                _builder_1.newLine();
                _builder_1.append("\t\t");
                _builder_1.append(object, "\t\t");
                _builder_1.append(" _");
                String _firstLower = StringExtensions.toFirstLower(object);
                _builder_1.append(_firstLower, "\t\t");
                _builder_1.append(" = mapper.readValue(expressionResult, ");
                _builder_1.append(object, "\t\t");
                _builder_1.append(".class);");
                _builder_1.newLineIfNotEmpty();
                _builder_1.append("\t\t");
                _builder_1.append("return _");
                String _firstLower_1 = StringExtensions.toFirstLower(object);
                _builder_1.append(_firstLower_1, "\t\t");
                _builder_1.append(";");
                _builder_1.newLineIfNotEmpty();
                _builder_1.append("\t");
                _builder_1.append("}");
                _builder_1.newLine();
                _builder_1.append("\t");
                _builder_1.newLine();
                String _plus_1 = (methodBody + _builder_1);
                methodBody = _plus_1;
              }
              count = (count + 1);
            }
          }
        }
      }
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("package com.example;");
      _builder_1.newLine();
      _builder_1.newLine();
      _builder_1.append("import org.springframework.beans.factory.annotation.Autowired;");
      _builder_1.newLine();
      _builder_1.append("import org.springframework.expression.*;");
      _builder_1.newLine();
      _builder_1.append("import org.springframework.expression.common.TemplateParserContext;");
      _builder_1.newLine();
      _builder_1.append("import org.springframework.expression.spel.standard.SpelExpressionParser;");
      _builder_1.newLine();
      _builder_1.append("import org.springframework.expression.spel.support.StandardEvaluationContext;");
      _builder_1.newLine();
      _builder_1.append("import org.springframework.stereotype.Component;");
      _builder_1.newLine();
      {
        Set<String> _keySet_1 = typeMap.keySet();
        for(final String key_1 : _keySet_1) {
          _builder_1.append("import com.example.models.");
          Pair<String, String> _get = typeMap.get(key_1);
          String _value = _get.getValue();
          _builder_1.append(_value, "");
          _builder_1.append(";");
          _builder_1.newLineIfNotEmpty();
          _builder_1.append("import com.example.models.");
          Pair<String, String> _get_1 = typeMap.get(key_1);
          String _value_1 = _get_1.getValue();
          _builder_1.append(_value_1, "");
          _builder_1.append("Repository;");
          _builder_1.newLineIfNotEmpty();
        }
      }
      _builder_1.append("import com.fasterxml.jackson.databind.*;");
      _builder_1.newLine();
      _builder_1.append("import com.github.fge.jsonpatch.JsonPatch;");
      _builder_1.newLine();
      _builder_1.append("import com.github.fge.jsonpatch.mergepatch.JsonMergePatch;");
      _builder_1.newLine();
      _builder_1.newLine();
      _builder_1.append("@Component");
      _builder_1.newLine();
      _builder_1.append("public class SkeletonHelper {");
      _builder_1.newLine();
      {
        Set<String> _keySet_2 = typeMap.keySet();
        for(final String key_2 : _keySet_2) {
          _builder_1.append("\t");
          _builder_1.append("@Autowired");
          _builder_1.newLine();
          _builder_1.append("\t");
          Pair<String, String> _get_2 = typeMap.get(key_2);
          String _value_2 = _get_2.getValue();
          _builder_1.append(_value_2, "\t");
          _builder_1.append("Repository ");
          _builder_1.append(key_2, "\t");
          _builder_1.append(";");
          _builder_1.newLineIfNotEmpty();
          _builder_1.newLine();
        }
      }
      _builder_1.append("\t");
      _builder_1.append("ObjectMapper mapper = new ObjectMapper().findAndRegisterModules();");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("StandardEvaluationContext spelContext;");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("ExpressionParser spelParser;");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("class LocalSpelContext {");
      _builder_1.newLine();
      {
        Set<String> _keySet_3 = typeMap.keySet();
        for(final String key_3 : _keySet_3) {
          _builder_1.append("\t\t");
          _builder_1.append("public ");
          Pair<String, String> _get_3 = typeMap.get(key_3);
          String _value_3 = _get_3.getValue();
          _builder_1.append(_value_3, "\t\t");
          _builder_1.append("Repository $");
          Pair<String, String> _get_4 = typeMap.get(key_3);
          String _value_4 = _get_4.getValue();
          _builder_1.append(_value_4, "\t\t");
          _builder_1.append("s = ");
          _builder_1.append(key_3, "\t\t");
          _builder_1.append(";");
          _builder_1.newLineIfNotEmpty();
        }
      }
      _builder_1.append("\t\t");
      _builder_1.append("public String $toJson(Object o) throws Exception {");
      _builder_1.newLine();
      _builder_1.append("\t\t\t");
      _builder_1.append("return mapper.writeValueAsString(o);");
      _builder_1.newLine();
      _builder_1.append("\t\t");
      _builder_1.append("}\t\t");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("}");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("public JsonNode $mergePatch(JsonNode obj, String json) throws Exception {");
      _builder_1.newLine();
      _builder_1.append("\t\t");
      _builder_1.append("JsonMergePatch mp = mapper.readValue(json, JsonMergePatch.class);");
      _builder_1.newLine();
      _builder_1.append("\t\t");
      _builder_1.append("return mp.apply(obj);");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("}");
      _builder_1.newLine();
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("public JsonNode $patch(JsonNode obj, String json) throws Exception {");
      _builder_1.newLine();
      _builder_1.append("\t\t");
      _builder_1.append("JsonPatch mp = mapper.readValue(json, JsonPatch.class);");
      _builder_1.newLine();
      _builder_1.append("\t\t");
      _builder_1.append("return mp.apply(obj);");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("}");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.newLine();
      String completeBody = _builder_1.toString();
      StringConcatenation _builder_2 = new StringConcatenation();
      String fixtureString = _builder_2.toString();
      Set<String> _keySet_4 = typeMap.keySet();
      for (final String key_4 : _keySet_4) {
        StringConcatenation _builder_3 = new StringConcatenation();
        _builder_3.append("//");
        _builder_3.newLine();
        _builder_3.append("\t\t");
        _builder_3.append("for (String json: ");
        Pair<String, String> _get_5 = typeMap.get(key_4);
        String _key = _get_5.getKey();
        _builder_3.append(_key, "\t\t");
        _builder_3.append(") {");
        _builder_3.newLineIfNotEmpty();
        _builder_3.append("\t\t\t");
        _builder_3.append("Expression expression = spelParser.parseExpression(json, new TemplateParserContext());");
        _builder_3.newLine();
        _builder_3.append("\t\t\t");
        _builder_3.append("String rewrittenJson = expression.getValue(spelContext, String.class);");
        _builder_3.newLine();
        _builder_3.append("\t\t\t");
        _builder_3.append(key_4, "\t\t\t");
        _builder_3.append(".save(mapper.readValue(rewrittenJson, ");
        Pair<String, String> _get_6 = typeMap.get(key_4);
        String _value_5 = _get_6.getValue();
        _builder_3.append(_value_5, "\t\t\t");
        _builder_3.append(".class));");
        _builder_3.newLineIfNotEmpty();
        _builder_3.append("\t\t");
        _builder_3.append("}");
        _builder_3.newLine();
        String _plus_1 = (fixtureString + _builder_3);
        fixtureString = _plus_1;
      }
      StringConcatenation _builder_4 = new StringConcatenation();
      _builder_4.append("//");
      _builder_4.newLine();
      _builder_4.append("\t");
      _builder_4.append("public void setupBackground() throws Exception {\t\t");
      _builder_4.newLine();
      _builder_4.append("\t\t");
      _builder_4.append("spelContext = new StandardEvaluationContext(new LocalSpelContext());");
      _builder_4.newLine();
      _builder_4.append("\t\t");
      _builder_4.append("spelParser = new SpelExpressionParser();");
      _builder_4.newLine();
      _builder_4.append("\t\t");
      _builder_4.append("spelContext.registerFunction(\"$toJson\", LocalSpelContext.class.getDeclaredMethod(\"$toJson\", new Class[] { Object.class }));");
      _builder_4.newLine();
      String _plus_2 = ((completeBody + fixtures) + _builder_4);
      String _plus_3 = (_plus_2 + fixtureString);
      StringConcatenation _builder_5 = new StringConcatenation();
      _builder_5.append("//");
      _builder_5.newLine();
      _builder_5.append("\t");
      _builder_5.append("}");
      _builder_5.newLine();
      String _plus_4 = (_plus_3 + _builder_5);
      String _plus_5 = (_plus_4 + methodBody);
      StringConcatenation _builder_6 = new StringConcatenation();
      _builder_6.append("}");
      _builder_6.newLine();
      _xblockexpression = (_plus_5 + _builder_6);
    }
    return _xblockexpression;
  }
  
  public String generateTest(final Feature feature) {
    String _xblockexpression = null;
    {
      StringConcatenation _builder = new StringConcatenation();
      String testBody = _builder.toString();
      EList<EObject> _scenarios = feature.getScenarios();
      for (final EObject scenario : _scenarios) {
        if ((scenario instanceof Scenario)) {
          Pattern scenarioSelectPattern = Pattern.compile("[.+]?scenario\\s\"(.+)\"\\swith\\s\\[([0-9]+)\\]");
          Pattern pathVariablePattern = Pattern.compile("/\\{(\\w+)\\}/?");
          String _title = ((Scenario)scenario).getTitle();
          String _testHeading = this.getTestHeading(_title);
          String testMethodHeader = ("test" + _testHeading);
          String _title_1 = ((Scenario)scenario).getTitle();
          String _title_2 = ((Scenario)scenario).getTitle();
          int _lastIndexOf = _title_2.lastIndexOf(" ");
          int _plus = (_lastIndexOf + 1);
          String object = _title_1.substring(_plus);
          String newObject = new String();
          StringConcatenation _builder_1 = new StringConcatenation();
          String stepBody = _builder_1.toString();
          EList<Step> _steps = ((Scenario)scenario).getSteps();
          for (final Step step : _steps) {
            {
              String _description = step.getDescription();
              Matcher scenarioSelectMatcher = scenarioSelectPattern.matcher(_description);
              boolean _find = scenarioSelectMatcher.find();
              if (_find) {
                String scenarioTitle = scenarioSelectMatcher.group(1);
                String exampleIndex = scenarioSelectMatcher.group(2);
                HashMap<String, ArrayList<String>> _get = this.methods.get(scenarioTitle);
                ArrayList<String> methodStrList = _get.get(exampleIndex);
                String methodName = methodStrList.get(0);
                String uri = methodStrList.get(2);
                String verb = methodStrList.get(3);
                String status = methodStrList.get(4);
                String reqBody = methodStrList.get(5);
                String checkerVariable = methodStrList.get(6);
                String checkerVarValue = methodStrList.get(7);
                Matcher pathVariableMatcher = pathVariablePattern.matcher(uri);
                boolean isPathVariableNotEMpty = pathVariableMatcher.find();
                String _description_1 = step.getDescription();
                int _indexOf = _description_1.indexOf("\"");
                int stIndex = (_indexOf + 1);
                String _description_2 = step.getDescription();
                int endIndex = _description_2.lastIndexOf("\"");
                String _description_3 = step.getDescription();
                String temp1 = _description_3.substring(stIndex, endIndex);
                int _lastIndexOf_1 = temp1.lastIndexOf(" ");
                int _plus_1 = (_lastIndexOf_1 + 1);
                String currentObject = temp1.substring(_plus_1);
                boolean _equals = currentObject.equals(object);
                if (_equals) {
                  StringConcatenation _builder_2 = new StringConcatenation();
                  _builder_2.append("//");
                  _builder_2.newLine();
                  {
                    boolean _isNullOrEmpty = StringExtensions.isNullOrEmpty(reqBody);
                    boolean _not = (!_isNullOrEmpty);
                    if (_not) {
                      _builder_2.append("\t\t");
                      String _firstLower = StringExtensions.toFirstLower(object);
                      _builder_2.append(_firstLower, "\t\t");
                      _builder_2.append(" = helper.get");
                      String _firstUpper = StringExtensions.toFirstUpper(methodName);
                      _builder_2.append(_firstUpper, "\t\t");
                      _builder_2.append("Data();");
                      _builder_2.newLineIfNotEmpty();
                    }
                  }
                  _builder_2.append("\t\t");
                  _builder_2.append("result = mockMvc.perform(");
                  String _lowerCase = verb.toLowerCase();
                  _builder_2.append(_lowerCase, "\t\t");
                  _builder_2.append("(\"/generated");
                  _builder_2.append(uri, "\t\t");
                  _builder_2.append("\"");
                  {
                    if (isPathVariableNotEMpty) {
                      _builder_2.append(",_");
                      String _firstLower_1 = StringExtensions.toFirstLower(object);
                      _builder_2.append(_firstLower_1, "\t\t");
                      _builder_2.append(".get_id()");
                    }
                  }
                  {
                    boolean _find_1 = pathVariableMatcher.find();
                    if (_find_1) {
                      _builder_2.append(",_");
                      String _firstLower_2 = StringExtensions.toFirstLower(newObject);
                      _builder_2.append(_firstLower_2, "\t\t");
                      _builder_2.append(".get_id()");
                    }
                  }
                  _builder_2.append(")");
                  _builder_2.newLineIfNotEmpty();
                  _builder_2.append("\t\t\t\t\t\t\t\t");
                  _builder_2.append(".header(\"keepAlive\", true)");
                  {
                    boolean _and = false;
                    boolean _isNullOrEmpty_1 = StringExtensions.isNullOrEmpty(reqBody);
                    if (!_isNullOrEmpty_1) {
                      _and = false;
                    } else {
                      _and = isPathVariableNotEMpty;
                    }
                    if (_and) {
                      _builder_2.append(")");
                    }
                  }
                  {
                    boolean _isNullOrEmpty_2 = StringExtensions.isNullOrEmpty(reqBody);
                    boolean _not_1 = (!_isNullOrEmpty_2);
                    if (_not_1) {
                      _builder_2.newLineIfNotEmpty();
                      _builder_2.append("\t\t\t\t\t\t\t\t");
                      _builder_2.append(".content(mapper.writeValueAsString(");
                      String _firstLower_3 = StringExtensions.toFirstLower(object);
                      _builder_2.append(_firstLower_3, "\t\t\t\t\t\t\t\t");
                      _builder_2.append("))");
                      _builder_2.newLineIfNotEmpty();
                      _builder_2.append("\t\t\t\t\t\t\t\t");
                      _builder_2.append(".contentType(MediaType.APPLICATION_JSON)");
                      {
                        boolean _isNullOrEmpty_3 = StringExtensions.isNullOrEmpty(reqBody);
                        boolean _not_2 = (!_isNullOrEmpty_3);
                        if (_not_2) {
                          _builder_2.append(")");
                        }
                      }
                    }
                  }
                  _builder_2.newLineIfNotEmpty();
                  _builder_2.append("\t\t\t\t\t\t\t\t");
                  _builder_2.append(".andExpect(status().is(");
                  _builder_2.append(status, "\t\t\t\t\t\t\t\t");
                  _builder_2.append("))");
                  _builder_2.newLineIfNotEmpty();
                  _builder_2.append("\t\t\t\t\t\t\t\t");
                  _builder_2.append(".andReturn();");
                  _builder_2.newLine();
                  _builder_2.append("\t\t");
                  _builder_2.newLine();
                  _builder_2.append("\t\t");
                  _builder_2.append("_");
                  String _firstLower_4 = StringExtensions.toFirstLower(object);
                  _builder_2.append(_firstLower_4, "\t\t");
                  _builder_2.append(" = mapper.readValue(result.getResponse().getContentAsString(), ");
                  _builder_2.append(object, "\t\t");
                  _builder_2.append(".class);");
                  _builder_2.newLineIfNotEmpty();
                  _builder_2.append("\t\t");
                  _builder_2.append("Assert.assertThat(_");
                  String _firstLower_5 = StringExtensions.toFirstLower(currentObject);
                  _builder_2.append(_firstLower_5, "\t\t");
                  _builder_2.append(".get");
                  String _firstUpper_1 = StringExtensions.toFirstUpper(checkerVariable);
                  _builder_2.append(_firstUpper_1, "\t\t");
                  _builder_2.append("().toString(), equalTo(\"");
                  _builder_2.append(checkerVarValue, "\t\t");
                  _builder_2.append("\"));");
                  _builder_2.newLineIfNotEmpty();
                  _builder_2.append("\t\t");
                  _builder_2.newLine();
                  String _plus_2 = (stepBody + _builder_2);
                  stepBody = _plus_2;
                } else {
                  newObject = currentObject;
                  String _firstLower_6 = StringExtensions.toFirstLower(currentObject);
                  String _plus_3 = ((currentObject + " _") + _firstLower_6);
                  String _plus_4 = (_plus_3 + " = null;");
                  boolean _contains = stepBody.contains(_plus_4);
                  boolean _not_3 = (!_contains);
                  if (_not_3) {
                    StringConcatenation _builder_3 = new StringConcatenation();
                    _builder_3.append("//\t\t");
                    _builder_3.newLine();
                    _builder_3.append("\t\t");
                    _builder_3.append(currentObject, "\t\t");
                    _builder_3.append(" _");
                    String _firstLower_7 = StringExtensions.toFirstLower(currentObject);
                    _builder_3.append(_firstLower_7, "\t\t");
                    _builder_3.append(" = null;");
                    _builder_3.newLineIfNotEmpty();
                    _builder_3.append("\t\t");
                    _builder_3.append(currentObject, "\t\t");
                    _builder_3.append(" ");
                    String _firstLower_8 = StringExtensions.toFirstLower(currentObject);
                    _builder_3.append(_firstLower_8, "\t\t");
                    _builder_3.append(" = null;");
                    _builder_3.newLineIfNotEmpty();
                    String _plus_5 = (stepBody + _builder_3);
                    stepBody = _plus_5;
                  }
                  StringConcatenation _builder_4 = new StringConcatenation();
                  _builder_4.append("//");
                  _builder_4.newLine();
                  {
                    boolean _isNullOrEmpty_4 = StringExtensions.isNullOrEmpty(reqBody);
                    boolean _not_4 = (!_isNullOrEmpty_4);
                    if (_not_4) {
                      _builder_4.append("\t\t");
                      String _firstLower_9 = StringExtensions.toFirstLower(currentObject);
                      _builder_4.append(_firstLower_9, "\t\t");
                      _builder_4.append(" = helper.get");
                      String _firstUpper_2 = StringExtensions.toFirstUpper(methodName);
                      _builder_4.append(_firstUpper_2, "\t\t");
                      _builder_4.append("Data();");
                      _builder_4.newLineIfNotEmpty();
                    }
                  }
                  _builder_4.append("\t\t");
                  _builder_4.append("result = mockMvc.perform(");
                  String _lowerCase_1 = verb.toLowerCase();
                  _builder_4.append(_lowerCase_1, "\t\t");
                  _builder_4.append("(\"/generated");
                  _builder_4.append(uri, "\t\t");
                  _builder_4.append("\"");
                  {
                    if (isPathVariableNotEMpty) {
                      _builder_4.append(",_");
                      String _firstLower_10 = StringExtensions.toFirstLower(object);
                      _builder_4.append(_firstLower_10, "\t\t");
                      _builder_4.append(".get_id()");
                    }
                  }
                  _builder_4.append(")");
                  _builder_4.newLineIfNotEmpty();
                  _builder_4.append("\t\t\t\t\t\t\t\t");
                  _builder_4.append(".header(\"keepAlive\", true)");
                  {
                    boolean _and_1 = false;
                    boolean _isNullOrEmpty_5 = StringExtensions.isNullOrEmpty(reqBody);
                    if (!_isNullOrEmpty_5) {
                      _and_1 = false;
                    } else {
                      _and_1 = isPathVariableNotEMpty;
                    }
                    if (_and_1) {
                      _builder_4.append(")");
                    }
                  }
                  {
                    boolean _isNullOrEmpty_6 = StringExtensions.isNullOrEmpty(reqBody);
                    boolean _not_5 = (!_isNullOrEmpty_6);
                    if (_not_5) {
                      _builder_4.newLineIfNotEmpty();
                      _builder_4.append("\t\t\t\t\t\t\t\t");
                      _builder_4.append(".content(mapper.writeValueAsString(");
                      String _firstLower_11 = StringExtensions.toFirstLower(currentObject);
                      _builder_4.append(_firstLower_11, "\t\t\t\t\t\t\t\t");
                      _builder_4.append("))");
                      _builder_4.newLineIfNotEmpty();
                      _builder_4.append("\t\t\t\t\t\t\t\t");
                      _builder_4.append(".contentType(MediaType.APPLICATION_JSON)");
                      {
                        boolean _isNullOrEmpty_7 = StringExtensions.isNullOrEmpty(reqBody);
                        boolean _not_6 = (!_isNullOrEmpty_7);
                        if (_not_6) {
                          _builder_4.append(")");
                        }
                      }
                    }
                  }
                  _builder_4.newLineIfNotEmpty();
                  _builder_4.append("\t\t\t\t\t\t\t\t");
                  _builder_4.append(".andExpect(status().is(");
                  _builder_4.append(status, "\t\t\t\t\t\t\t\t");
                  _builder_4.append("))");
                  _builder_4.newLineIfNotEmpty();
                  _builder_4.append("\t\t\t\t\t\t\t\t");
                  _builder_4.append(".andReturn();");
                  _builder_4.newLine();
                  _builder_4.append("\t\t");
                  _builder_4.newLine();
                  _builder_4.append("\t\t");
                  _builder_4.append("_");
                  String _firstLower_12 = StringExtensions.toFirstLower(currentObject);
                  _builder_4.append(_firstLower_12, "\t\t");
                  _builder_4.append(" = mapper.readValue(result.getResponse().getContentAsString(), ");
                  _builder_4.append(currentObject, "\t\t");
                  _builder_4.append(".class);");
                  _builder_4.newLineIfNotEmpty();
                  _builder_4.append("\t\t");
                  _builder_4.append("Assert.assertThat(_");
                  String _firstLower_13 = StringExtensions.toFirstLower(currentObject);
                  _builder_4.append(_firstLower_13, "\t\t");
                  _builder_4.append(".get");
                  String _firstUpper_3 = StringExtensions.toFirstUpper(checkerVariable);
                  _builder_4.append(_firstUpper_3, "\t\t");
                  _builder_4.append("().toString(), equalTo(\"");
                  _builder_4.append(checkerVarValue, "\t\t");
                  _builder_4.append("\"));");
                  _builder_4.newLineIfNotEmpty();
                  _builder_4.append("\t\t");
                  _builder_4.newLine();
                  String _plus_6 = (stepBody + _builder_4);
                  stepBody = _plus_6;
                }
              }
            }
          }
          StringConcatenation _builder_2 = new StringConcatenation();
          _builder_2.newLine();
          _builder_2.append("\t");
          _builder_2.append("@Test");
          _builder_2.newLine();
          _builder_2.append("\t");
          _builder_2.append("public void ");
          _builder_2.append(testMethodHeader, "\t");
          _builder_2.append("() throws Exception {");
          _builder_2.newLineIfNotEmpty();
          _builder_2.append("\t\t");
          _builder_2.append("MvcResult result = null;");
          _builder_2.newLine();
          _builder_2.append("\t\t");
          _builder_2.append(object, "\t\t");
          _builder_2.append(" _");
          String _firstLower = StringExtensions.toFirstLower(object);
          _builder_2.append(_firstLower, "\t\t");
          _builder_2.append(" = null;");
          _builder_2.newLineIfNotEmpty();
          _builder_2.append("\t\t");
          _builder_2.append(object, "\t\t");
          _builder_2.append(" ");
          String _firstLower_1 = StringExtensions.toFirstLower(object);
          _builder_2.append(_firstLower_1, "\t\t");
          _builder_2.append(" = null;");
          _builder_2.newLineIfNotEmpty();
          String _plus_1 = (testBody + _builder_2);
          String _plus_2 = (_plus_1 + stepBody);
          StringConcatenation _builder_3 = new StringConcatenation();
          _builder_3.append("//");
          _builder_3.newLine();
          _builder_3.append("    ");
          _builder_3.append("}");
          _builder_3.newLine();
          _builder_3.append("    ");
          _builder_3.newLine();
          String _plus_3 = (_plus_2 + _builder_3);
          testBody = _plus_3;
        }
      }
      StringConcatenation _builder_4 = new StringConcatenation();
      _builder_4.append("package com.example;");
      _builder_4.newLine();
      _builder_4.newLine();
      _builder_4.append("import org.junit.*;");
      _builder_4.newLine();
      _builder_4.append("import org.junit.runner.RunWith;");
      _builder_4.newLine();
      _builder_4.append("import org.springframework.beans.factory.annotation.*;");
      _builder_4.newLine();
      _builder_4.append("import org.springframework.boot.test.SpringApplicationConfiguration;");
      _builder_4.newLine();
      _builder_4.append("import org.springframework.http.MediaType;");
      _builder_4.newLine();
      _builder_4.append("import org.springframework.test.annotation.DirtiesContext;");
      _builder_4.newLine();
      _builder_4.append("import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;");
      _builder_4.newLine();
      _builder_4.append("import org.springframework.test.context.web.WebAppConfiguration;");
      _builder_4.newLine();
      _builder_4.append("import org.springframework.test.web.servlet.*;");
      _builder_4.newLine();
      _builder_4.append("import org.springframework.test.web.servlet.setup.MockMvcBuilders;");
      _builder_4.newLine();
      _builder_4.append("import org.springframework.web.context.WebApplicationContext;");
      _builder_4.newLine();
      _builder_4.newLine();
      _builder_4.append("import com.example.models.*;");
      _builder_4.newLine();
      _builder_4.append("import com.fasterxml.jackson.databind.ObjectMapper;");
      _builder_4.newLine();
      _builder_4.newLine();
      _builder_4.append("import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.*;");
      _builder_4.newLine();
      _builder_4.append("import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.*;");
      _builder_4.newLine();
      _builder_4.append("import static org.hamcrest.CoreMatchers.equalTo;");
      _builder_4.newLine();
      _builder_4.newLine();
      _builder_4.append("@RunWith(SpringJUnit4ClassRunner.class)");
      _builder_4.newLine();
      _builder_4.append("@SpringApplicationConfiguration(classes = DemoApplication.class)");
      _builder_4.newLine();
      _builder_4.append("@WebAppConfiguration");
      _builder_4.newLine();
      _builder_4.append("@DirtiesContext");
      _builder_4.newLine();
      _builder_4.append("public class SkeletonTest {");
      _builder_4.newLine();
      _builder_4.append("\t");
      _builder_4.append("@Autowired");
      _builder_4.newLine();
      _builder_4.append("\t");
      _builder_4.append("SkeletonHelper helper;");
      _builder_4.newLine();
      _builder_4.append("\t\t\t\t");
      _builder_4.newLine();
      _builder_4.append("\t");
      _builder_4.append("@Autowired");
      _builder_4.newLine();
      _builder_4.append("\t");
      _builder_4.append("private WebApplicationContext wac;");
      _builder_4.newLine();
      _builder_4.newLine();
      _builder_4.append("\t");
      _builder_4.append("@Autowired");
      _builder_4.newLine();
      _builder_4.append("\t");
      _builder_4.append("@Qualifier(\"_halObjectMapper\")");
      _builder_4.newLine();
      _builder_4.append("\t");
      _builder_4.append("ObjectMapper mapper;");
      _builder_4.newLine();
      _builder_4.newLine();
      _builder_4.append("\t");
      _builder_4.append("private MockMvc mockMvc;");
      _builder_4.newLine();
      _builder_4.newLine();
      _builder_4.append("\t");
      _builder_4.append("@Before");
      _builder_4.newLine();
      _builder_4.append("\t");
      _builder_4.append("public void setup() throws Exception {");
      _builder_4.newLine();
      _builder_4.append("\t\t");
      _builder_4.append("this.mockMvc = MockMvcBuilders.webAppContextSetup(this.wac).build();");
      _builder_4.newLine();
      _builder_4.append("\t\t");
      _builder_4.append("helper.setupBackground();");
      _builder_4.newLine();
      _builder_4.append("\t\t");
      _builder_4.append("mockMvc.perform(post(\"/generated/initialize\"));");
      _builder_4.newLine();
      _builder_4.append("\t");
      _builder_4.append("}");
      _builder_4.newLine();
      _builder_4.newLine();
      String _plus_4 = (_builder_4.toString() + testBody);
      StringConcatenation _builder_5 = new StringConcatenation();
      _builder_5.append("}");
      _builder_5.newLine();
      _xblockexpression = (_plus_4 + _builder_5);
    }
    return _xblockexpression;
  }
  
  public String getTestHeading(final String title) {
    StringBuilder sb = new StringBuilder(title);
    Pattern pattern = Pattern.compile("\\s\\w");
    Matcher matcher = pattern.matcher(sb);
    int pos = 0;
    while (matcher.find(pos)) {
      {
        String _group = matcher.group();
        String _substring = _group.substring(1);
        String replacement = _substring.toUpperCase();
        int _start = matcher.start();
        pos = _start;
        sb.replace(pos, (pos + 2), replacement);
        int _pos = pos;
        pos = (_pos + 1);
      }
    }
    return sb.toString();
  }
}
